#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "repstr.h"

static char header_code[]=
"\n"
"namespace FX {\n"
"class FXAPI $CLASS : public FXScrollArea {\n"
"\011FXDECLARE($CLASS)\n"
"protected:\n"
"\011$CLASS();\n"
"private:\n"
"\011$CLASS(const $CLASS&);\n"
"\011$CLASS &operator=(const $CLASS&);\n"
"\n"
"\011FXApp* myapp;\n"
"\n"
"private:\n"
"\011int input_r;\n"
"\011int input_c;\n"
"\n"
"\011FXFont *data_font;\n"
"\011FXFont *header_font;\n"
"\011int data_font_ascent;\n"
"\011int header_font_ascent;\n"
"\011int data_font_height;\n"
"\011int header_font_height;\n"
"\011int data_font_swidth;\n"
"\011int header_font_swidth;\n"
"\n"
"\011FXTextField *editor;\n"
"private:\n"
"\011typedef struct { int y; int x1; int x2; } xline_t;\n"
"\011typedef struct { int x; int y1; int y2; } yline_t;\n"
"\011typedef struct { int x1,y1; int x2,y2; } crect_t;\n"
"\011typedef struct { crect_t area; unsigned color; } bgfill_def_t;\n"
"\011typedef struct { crect_t area; FXColor color; } bgfill_act_t;\n"
"\n"
"\011typedef enum { $FIELD_ENUMS  } cell_storage_kind_t;\n"
"\011typedef enum { cell_int, cell_str } cell_base_type_t;\n"
"\n"
"\011typedef enum\n"
"\011\011{ ck_merged, ck_empty, ck_data, ck_header }\n"
"\011\011\011cell_kind_t;\n"
"\n"
"\011typedef struct\n"
"\011\011{ cell_kind_t kind; int halign, valign;\n"
"\011\011   int rowspan, colspan;\n"
"\011\011   int merge_r, merge_c; int editable;\n"
"\011\011\011cell_base_type_t  base_type;\n"
"\011\011   cell_storage_kind_t skind;\n"
"\011\011   int idx1, idx2;\n"
"\011\011   const char *format;\n"
"\011\011   int show_if_zero;\n"
"\011\011 } cell_def_t;\n"
"\n"
"\011typedef struct\n"
"\011\011{ int cwidth, cheight;\n"
"\011\011char *data; } cell_t;\n"
"\n"
"\011static const xline_t horz_line_defs[$NHORZLINES];\n"
"\011static const yline_t vert_line_defs[$NVERTLINES];\n"
"\011static const bgfill_def_t bgfill_defs[$NBGFILLS];\n"
"\011static const cell_def_t cell_defs[$NROWS][$NCOLS];\n"
"\n"
"\011xline_t horz_lines[$NHORZLINES];\n"
"\011yline_t vert_lines[$NVERTLINES];\n"
"\011bgfill_act_t bgfills[$NBGFILLS];\n"
"\n"
"\011cell_t cells[$NROWS][$NCOLS];\n"
"\n"
"\011int row_heights[$NROWS];\n"
"\011int col_widths[$NCOLS];\n"
"\011int x_offsets[$NCOLS+1];\n"
"\011int y_offsets[$NROWS+1];\n"
"\n"
"\011int x_pad, y_pad;\n"
"\n"
"\011void get_text_size(int bold,char *data, int *w,int *h);\n"
"\011void get_single_line_text_size\n"
"\011\011(FXFont* font,char*data,int *tw,int *th);\n"
"\n"
"\011int render_text_line\n"
"\011\011(FXDC* dc,FXFont *font,int X, int Y,\n"
"\011\011int halign, char *data, int avail_w);\n"
"\011void render_text\n"
"\011\011(FXDC* dc,crect_t area, int valign,int halign, int bold,\n"
"\011\011char *data,int content_width,int content_height);\n"
"\n"
"\011int calculate_col_widths();\n"
"\011int calculate_row_heights();\n"
"\011void calculate_cell_geometry(int r,int c);\n"
"\011void calculate_cell_content_geometries();\n"
"\011void convert_to_actual_coordinates();\n"
"\n"
"\011int ceil(int a,int b);\n"
"\011int classify_point(crect_t R, int x,int y);\n"
"\011int rectangles_intersect(crect_t R1,crect_t R2);\n"
"\011int xline_visible(crect_t R, xline_t L);\n"
"\011int yline_visible(crect_t R,yline_t L);\n"
"\011FXColor rgb24tofxcolor(unsigned int x);\n"
"\011int fit_to_range(int x,int min,int max);\n"
"\011int unformat_int(char *txt,const char *fmt);\n"
"\011char *unformat_str(char *txt,const char *fmt);\n"
"\011char* format_int(int v,const char *fmt);\n"
"\011char *format_str(char *txt,const char *fmt);\n"
"\n"
"\011void make_cell_visible(int r,int c);\n"
"public:\n"
"\011class boxed_int {\n"
"\011public:\n"
"\011\011int value;\n"
"\011\011$CLASS* table;\n"
"\011\011void set(int v);\n"
"\011\011int row,col;\n"
"\011\011void init($CLASS *tb,int r,int c);\n"
"\011\011void start_edit();\n"
"\011\011void serialize(char **buffer,size_t *len);\n"
"\011\011void deserialize(char **buffer,size_t *len);\n"
"\011};\n"
"\n"
"\011class boxed_str {\n"
"\011public:\n"
"\011\011char *value;\n"
"\011\011$CLASS* table;\n"
"\011\011void set(char *v);\n"
"\011\011int row,col;\n"
"\011\011void init($CLASS *tb,int r,int c);\n"
"\011\011void start_edit();\n"
"\011\011void serialize(char **buffer,size_t *len);\n"
"\011\011void deserialize(char **buffer,size_t *len);\n"
"\011};\n"
"\n"
"\011struct {\n"
"\011\011$STORAGE_DECLARATIONS\n"
"\011} S;\n"
"\n"
"\011typedef struct {\n"
"\011\011$RAW_STORAGE_DECLARATIONS\n"
"\011} raw_storage_t;\n"
"\n"
"\011$CELL_CHANGE_CALLBACK_DECLARATIONS\n"
"\n"
"\011void serialize_data(char **buf,size_t *len);\n"
"\011void deserialize_data(char *buf, size_t len);\n"
"\n"
"\011static raw_storage_t* parse_data(char *buf,size_t len);\n"
"\011static void unparse_data(raw_storage_t *V,\n"
"\011\011char **buf,size_t*len);\n"
"\011static void destroy_data(raw_storage_t *obj);\n"
"\n"
"\011int show_if_zero(int row,int col);\n"
"\n"
"public:\n"
"\011$CLASS(FXComposite* p,\n"
"\011\011FXuint opts=FRAME_NORMAL,\n"
"\011\011FXint x=0,FXint y=0,FXint w=0,FXint h=0);\n"
"\011virtual ~$CLASS();\n"
"\n"
"\011enum { ID_UPDATECELL= FXScrollBar::ID_LAST+1, };\n"
"\n"
"\011enum { valign_top, valign_center, valign_bottom };\n"
"\011enum { halign_left, halign_center, halign_right };\n"
"\n"
"\011virtual bool canFocus() const { return true; }\n"
"\011virtual void create();\n"
"\011virtual void detach();\n"
"\n"
"\011virtual int getContentWidth();\n"
"\011virtual int getContentHeight();\n"
"\011virtual FXint getDefaultWidth();\n"
"\011virtual FXint getDefaultHeight();\n"
"\n"
"\011void begin_update();\n"
"\011void end_update();\n"
"\n"
"\011virtual void layout();\n"
"\n"
"\011long onPaint(FXObject*,FXSelector,void*);\n"
"\011long onClick(FXObject*,FXSelector,void*);\n"
"\011long onCellChange(FXObject*,FXSelector,void*);\n"
"\n"
"public:\n"
"\011int col(const char* X);\n"
"\011int editable;\n"
"\011void start_edit(int r,int c);\n"
"\011void set_cell_text(int r,int c,char *text);\n"
"\011void set_cell_text_noupdate(int r,int c,char *text);\n"
"};\n"
"\n"
"}\n"

      ; // end of header code

static char source_code[]= 
"#include <fx.h>\n"
"#include \042$FILENAME.h\042\n"
"\n"
"FXDEFMAP($CLASS) $CLASSMessageMap[]={\n"
"\011FXMAPFUNC(SEL_PAINT,0,$CLASS::onPaint),\n"
"\011FXMAPFUNC(SEL_LEFTBUTTONPRESS, 0, $CLASS::onClick),\n"
"\011FXMAPFUNC(SEL_COMMAND, $CLASS::ID_UPDATECELL,\n"
"\011\011\011$CLASS::onCellChange),\n"
"};\n"
"\n"
"FXIMPLEMENT($CLASS,FXScrollArea,\n"
"\011$CLASSMessageMap,ARRAYNUMBER($CLASSMessageMap))\n"
"\n"
"\n"
"\n"
"\n"
"void $CLASS::create() { \n"
"\011FXScrollArea::create();\n"
"\n"
"\011data_font= new FXFont(myapp,\042Courier New\042, 14);\n"
"\011data_font->create();\n"
"\011data_font_ascent= data_font->getFontAscent();\n"
"\011data_font_height= data_font->getFontHeight();\n"
"\011data_font_swidth= data_font->getCharWidth(\047 \047);\n"
"\n"
"\011header_font= new FXFont(myapp, \042Courier New\042, 14,FXFont::Bold);\n"
"\011header_font->create();\n"
"\011header_font_ascent= header_font->getFontAscent();\n"
"\011header_font_height= header_font->getFontHeight();\n"
"\011header_font_swidth= header_font->getCharWidth(\047 \047);\n"
"\n"
"\011calculate_cell_content_geometries();\n"
"\011calculate_col_widths();\n"
"\011calculate_row_heights();\n"
"\011convert_to_actual_coordinates();\n"
"\n"
"\011vertical->setLine(data_font_height);\n"
"\011horizontal->setLine(data_font_swidth);\n"
"}\n"
"\n"
"void $CLASS::serialize_data(char **buf,size_t *len) {\n"
"\011size_t *L;\n"
"\011char **B;\n"
"\n"
"\011char *buffer;\n"
"\011size_t buffer_len;\n"
"\n"
"\011buffer= 0;\n"
"\011buffer_len= 0;\n"
"\011L= &buffer_len;\n"
"\011B= &buffer;\n"
"\n"
"again:\n"
"\011$SERIALIZATION\n"
"\011if (buffer) return ;\n"
"\011buffer= (char*) malloc(buffer_len);\n"
"\011*buf= buffer;\n"
"\011*len= buffer_len;\n"
"\011buffer_len= 0;\n"
"\011goto again;\n"
"}\n"
"\n"
"static void unparse_int(char **buffer, size_t *len, int value)\n"
"{\n"
"\011if (*buffer) {\n"
"\011\011memcpy(*buffer, (void*) &value, sizeof(value));\n"
"\011\011*buffer += sizeof(value);\n"
"\011}\n"
"\011*len += sizeof(value);\n"
"}\n"
"static void unparse_str(char **buffer, size_t* len,char *value) {\n"
"\011int L;\n"
"\011if (value && value[0]) {\n"
"\011\011L= strlen(value);\n"
"\011} else L= 0;\n"
"\011unparse_int(buffer, len, L);\n"
"\011if (L) {\n"
"\011\011if (*buffer) {\n"
"\011\011\011memcpy(*buffer, value, L);\n"
"\011\011\011*buffer+= L;\n"
"\011\011}\n"
"\011\011*len+= L;\n"
"\011}\n"
"}\n"
"\n"
"\n"
"void $CLASS::unparse_data(raw_storage_t *V,char **buf,size_t *len) {\n"
"\011size_t *L;\n"
"\011char **B;\n"
"\n"
"\011char *buffer;\n"
"\011size_t buffer_len;\n"
"\n"
"\011buffer= 0;\n"
"\011buffer_len= 0;\n"
"\011L= &buffer_len;\n"
"\011B= &buffer;\n"
"\n"
"again:\n"
"\011$RAW_UNPARSING_CODE\n"
"\011if (buffer) return ;\n"
"\011buffer= (char*) malloc(buffer_len);\n"
"\011*buf= buffer;\n"
"\011*len= buffer_len;\n"
"\011buffer_len= 0;\n"
"\011goto again;\n"
"}\n"
"\n"
"void $CLASS::boxed_int::serialize(char **buffer,size_t *len) {\n"
"\011unparse_int(buffer,len,value);\n"
"}\n"
"\n"
"void $CLASS::boxed_str::serialize(char **buffer, size_t *len)\n"
"{\n"
"\011unparse_str(buffer,len,value);\n"
"}\n"
"\n"
"\n"
"static int parse_int(char **buffer,size_t *len)\n"
"{\n"
"\011int X=0;\n"
"\011if (*len>=sizeof(int)) {\n"
"\011\011memcpy((void*) &X, *buffer, sizeof(int));\n"
"\011\011*buffer+= sizeof(int);\n"
"\011\011*len-= sizeof(int);\n"
"\011}\n"
"\011return X;\n"
"}\n"
"\n"
"static char* parse_str(char **buffer,size_t *len) {\n"
"\011size_t L;\n"
"\011L= parse_int(buffer,len);\n"
"\011if (L && *len>=L) {\n"
"\011\011char *X;\n"
"\011\011X= (char*) malloc(L+1);\n"
"\011\011memcpy(X, *buffer, L);\n"
"\011\011X[L]= 0;\n"
"\011\011*buffer+= L;\n"
"\011\011*len-= L;\n"
"\011\011return X;\n"
"\011} else return 0;\n"
"}\n"
"\n"
"\n"
"\n"
"void $CLASS::boxed_int::deserialize(char **buffer,size_t *len)\n"
"{\n"
"\011value= parse_int(buffer,len);\n"
"\011if (value || table->show_if_zero(row,col)) {\n"
"\011\011char *X;\n"
"\011\011X= table->format_int(value, \n"
"\011\011\011table->cell_defs[row][col].format);\n"
"\011\011table->set_cell_text_noupdate(row,col,X);\n"
"\011\011free(X);\n"
"\011} else table->set_cell_text_noupdate(row,col,0);\n"
"}\n"
"\n"
"void $CLASS::boxed_str::deserialize(char **buffer,size_t *len)\n"
"{\n"
"\011if (value) free(value);\n"
"\011value= parse_str(buffer,len);\n"
"\011table->set_cell_text_noupdate(row,col,value);\n"
"}\n"
"\n"
"\n"
"void $CLASS::deserialize_data(char *buf,size_t len)\n"
"{\n"
"\011char **B;\n"
"\011size_t *L;\n"
"\011B= &buf;\n"
"\011L= &len;\n"
"\n"
"\011$DESERIALIZATION\n"
"\011calculate_cell_content_geometries();\n"
"\011calculate_col_widths();\n"
"\011calculate_row_heights();\n"
"\011convert_to_actual_coordinates();\n"
"\011layout();\n"
"\011update();\n"
"}\n"
"\n"
"void $CLASS::detach()\n"
"\011{ FXScrollArea::detach();}\n"
"\n"
"int $CLASS::getContentWidth()\n"
"\011{  return x_offsets[$NCOLS]; }\n"
"\n"
"int $CLASS::getContentHeight()\n"
"\011{ return y_offsets[$NROWS]; }\n"
"\n"
"int $CLASS::getDefaultWidth()\n"
"\011{ return x_offsets[$NCOLS]+vertical->getDefaultWidth() + 10;}\n"
"\n"
"int $CLASS::getDefaultHeight()\n"
"\011{ return y_offsets[$NROWS]+horizontal->getDefaultHeight()+5; }\n"
"\n"
"void $CLASS::layout() {\n"
"\011FXScrollArea::layout();\n"
"#if 0\n"
"\011int K;\n"
"\011K= x_offsets[$NCOLS];\n"
"\011if (K<width) x_pad= (width-K)/2;\n"
"\011K= y_offsets[$NROWS];\n"
"\011if (K<height) y_pad= (height-K)/2;\n"
"#endif\n"
"}\n"
"\n"
"\n"
"long $CLASS::onPaint(FXObject* ob,FXSelector sel,void* ptr){\n"
"\011FXEvent* event;\n"
"\011crect_t R;\n"
"\011int i,j;\n"
"\n"
"\011event=(FXEvent*)ptr;\n"
"\n"
"\011FXDCWindow dc(this,event);\n"
"\n"
"\011/* FIXME: subtract the painted areas from\n"
"\011\011this and then do the paint */\n"
"\011dc.setForeground(getBackColor());\n"
"\011dc.fillRectangle(event->rect.x,event->rect.y,\n"
"\011\011event->rect.w, event->rect.h);\n"
"\n"
"\011R.x1= event->rect.x- pos_x;\n"
"\011R.y1= event->rect.y- pos_y;\n"
"\011R.x2= R.x1+event->rect.w;\n"
"\011R.y2= R.y1+event->rect.h;\n"
"\n"
"\011/* now, R is in document coordinates */\n"
"\n"
"/*\011printf(\042PAINT! %d,%d  [%d,%d]\134n\042,R.x1,R.y1,R.x2,R.y2);\n"
"\011printf(\042WINDOW: %d %d\134n\042,getWidth(), getHeight());*/\n"
"\n"
"\011R.x1-= x_pad;\n"
"\011R.x2-= x_pad;\n"
"\011R.y1-= y_pad;\n"
"\011R.y2-= y_pad;\n"
"\n"
"\011for(i=0;i<$NBGFILLS;i++)\n"
"\011\011if (rectangles_intersect(R, bgfills[i].area)) {\n"
"\011\011\011dc.setForeground(bgfills[i].color);\n"
"\011\011\011dc.fillRectangle(\n"
"\011\011\011\011x_pad+bgfills[i].area.x1+pos_x,\n"
"\011\011\011\011y_pad+bgfills[i].area.y1+pos_y,\n"
"\011\011\011\011bgfills[i].area.x2-bgfills[i].area.x1,\n"
"\011\011\011\011bgfills[i].area.y2-bgfills[i].area.y1);\n"
"\011\011}\n"
"\n"
"\011dc.setForeground(rgb24tofxcolor(0x0));\n"
"\011for(i=0;i<$NHORZLINES;i++)\n"
"\011\011if (xline_visible(R, horz_lines[i]))\n"
"\011\011\011dc.drawLine(\n"
"\011\011\011\011x_pad+horz_lines[i].x1+pos_x,\n"
"\011\011\011\011y_pad+horz_lines[i].y+pos_y,\n"
"\011\011\011\011x_pad+horz_lines[i].x2+pos_x,\n"
"\011\011\011\011y_pad+horz_lines[i].y+pos_y);\n"
"\n"
"\011for(i=0;i<$NVERTLINES;i++)\n"
"\011\011if (yline_visible(R, vert_lines[i]))\n"
"\011\011\011dc.drawLine(\n"
"\011\011\011\011x_pad+vert_lines[i].x+pos_x,\n"
"\011\011\011\011y_pad+vert_lines[i].y1+pos_y,\n"
"\011\011\011\011x_pad+vert_lines[i].x+pos_x,\n"
"\011\011\011\011y_pad+vert_lines[i].y2+pos_y);\n"
"\n"
"\011for(i=0;i<$NROWS;i++)\n"
"\011\011for(j=0;j<$NCOLS;j++) {\n"
"\011\011\011cell_t *C;\n"
"\011\011\011const cell_def_t *def;\n"
"\011\011\011crect_t TR;\n"
"\011\011\011C= &cells[i][j];\n"
"\011\011\011def= &cell_defs[i][j];\n"
"\011\011\011if (def->kind!=ck_header && def->kind!=ck_data)\n"
"\011\011\011\011continue;\n"
"\011\011\011if (!C->data || !C->data[0])\n"
"\011\011\011\011continue;\n"
"\011\011\011TR.x1= x_offsets[j];\n"
"\011\011\011TR.y1= y_offsets[i];\n"
"\011\011\011TR.x2= x_offsets[j+def->colspan];\n"
"\011\011\011TR.y2= y_offsets[i+def->rowspan];\n"
"\011\011\011if (!rectangles_intersect(R, TR))\n"
"\011\011\011\011continue;\n"
"\011\011\011render_text(&dc, TR, def->valign, def->halign,\n"
"\011\011\011\011def->kind==ck_header, C->data,\n"
"\011\011\011\011C->cwidth, C->cheight);\n"
"\011\011}\n"
"\011\n"
"\011return 1;\n"
"}\n"
"\n"
"long $CLASS::onClick(FXObject* ob,FXSelector sel,void* ptr) {\n"
"\011FXEvent* event;\n"
"\011int x,y;\n"
"\011int r,c;\n"
"\n"
"\011event=(FXEvent*)ptr;\n"
"\n"
"\011if (!editable) return 1;\n"
"\011if (editor) {\n"
"\011\011delete editor;\n"
"\011\011editor= 0;\n"
"\011\011return 1;\n"
"\011}\n"
"\n"
"\011handle(this,FXSEL(SEL_FOCUS_SELF,0),ptr);\n"
"\011x= event->win_x-pos_x; y= event->win_y-pos_y;\n"
"\n"
"\011y-= y_pad;\n"
"\011x-= x_pad;\n"
"\n"
"\011for(r=0;r<$NROWS;r++)\n"
"\011\011if (y>=y_offsets[r] && y<y_offsets[r+1])\n"
"\011\011\011break;\n"
"\011if (r==$NROWS) return 1;\n"
"\n"
"\011for(c=0;c<$NCOLS;c++)\n"
"\011\011if (x>=x_offsets[c]&&x<x_offsets[c+1])\n"
"\011\011\011break;\n"
"\011if (c==$NCOLS) return 1;\n"
"\n"
"\011if (cell_defs[r][c].kind==ck_merged) {\n"
"\011\011int a,b;\n"
"\011\011a= r; b=c;\n"
"\011\011r= cell_defs[a][b].merge_r;\n"
"\011\011c= cell_defs[a][b].merge_c;\n"
"\011}\n"
"\011if (cell_defs[r][c].kind==ck_empty) return 1;\n"
"\011if (cell_defs[r][c].kind==ck_header) return 1;\n"
"\011if (!cell_defs[r][c].editable) return 1;\n"
"\n"
"\011start_edit(r,c);\n"
"\011return 1;\n"
"}\n"
"\n"
"void $CLASS::make_cell_visible(int r,int c)\n"
"{\n"
"\011int X= x_offsets[c]+pos_x;\n"
"\011int Y= y_offsets[r]+pos_y;\n"
"\011int W= x_offsets[c+cell_defs[r][c].colspan]-x_offsets[c];\n"
"\011int H= y_offsets[r+cell_defs[r][c].rowspan]-y_offsets[r];\n"
"\011int dx,dy;\n"
"\n"
"\011dx= dy= 0;\n"
"\n"
"\011if (X<0) { dx= X; X= 0; }\n"
"\n"
"\011if (X+W>=viewport_w) {\n"
"\011\011if (X!=0) {\n"
"\011\011\011dx+= -X;\n"
"\011\011\011X= 0;\n"
"\011\011}\n"
"\011}\n"
"\n"
"\011if (Y<0) { dy= Y; Y= 0; }\n"
"\n"
"\011if (Y+H>=viewport_h) {\n"
"\011\011if (Y!=0) {\n"
"\011\011\011dy+= -Y;\n"
"\011\011\011Y= 0;\n"
"\011\011}\n"
"\011}\n"
"\n"
"\011if (dx || dy) \n"
"\011\011setPosition(pos_x+dx,pos_y+dy);\n"
"}\n"
"\n"
"void $CLASS::start_edit(int r,int c) {\n"
"\n"
"\011if (r<0 || c<0 || r>=$NROWS || c>=$NCOLS)\n"
"\011\011return ;\n"
"\011make_cell_visible(r,c);\n"
"\011editor= new FXTextField(this, 1, NULL, 0,\n"
"\011\011FRAME_THICK, \n"
"\011\011\011x_pad+x_offsets[c]+pos_x,\n"
"\011\011\011y_pad+y_offsets[r]+pos_y,\n"
"\011\011\011x_offsets[c+cell_defs[r][c].colspan]-x_offsets[c],\n"
"\011\011\011y_offsets[r+cell_defs[r][c].rowspan]-y_offsets[r]);\n"
"\011editor->create();\n"
"\011if (cells[r][c].data)\n"
"\011\011editor->setText(cells[r][c].data);\n"
"\011editor->setFocus();\n"
"\011editor->setTarget(this);\n"
"\011editor->setSelector(ID_UPDATECELL);\n"
"\011editor->show();\n"
"\011input_r= r;\n"
"\011input_c= c;\n"
"}\n"
"\n"
"long $CLASS::onCellChange(FXObject* ob,FXSelector sel,void* ptr) {\n"
"\011char *text;\n"
"\011int intv;\n"
"\011char *strv;\n"
"\011int idx1,idx2;\n"
"\011text= strdup(editor->getText().text());\n"
"\011delete editor;\n"
"\011editor= 0;\n"
"\n"
"\011strv= 0;\n"
"\011switch (cell_defs[input_r][input_c].base_type) {\n"
"\011case cell_int:\n"
"\011\011intv= unformat_int(text,\n"
"\011\011\011\011cell_defs[input_r][input_c].format);\n"
"\011\011break;\n"
"\011case cell_str:\n"
"\011\011strv= unformat_str(text,\n"
"\011\011\011\011cell_defs[input_r][input_c].format);\n"
"\011}\n"
"\011idx1= cell_defs[input_r][input_c].idx1;\n"
"\011idx2= cell_defs[input_r][input_c].idx2;\n"
"\011switch(cell_defs[input_r][input_c].skind) {\n"
"\011$CELL_CHANGE_CALLBACK_CASES\n"
"\011}\n"
"\011free(text);\n"
"\n"
"\011if (strv) free(strv);\n"
"\011return 1;\n"
"}\n"
"\n"
"int $CLASS::col(const char* X)\n"
"{\n"
"\011int S=0;\n"
"\011while(*X) {\n"
"\011\011S= S*26 + X[0]-\047A\047;\n"
"\011\011X++;\n"
"\011}\n"
"\011return S;\n"
"}\n"
"\n"
"int $CLASS::fit_to_range(int x,int min,int max) {\n"
"\011if (x<min) return min;\n"
"\011else if (x>max) return max;\n"
"\011else return x;\n"
"}\n"
"\n"
"static void freeifnnull(char *x) {\n"
"\011if (x) free(x);\n"
"}\n"
"\n"
"$CLASS::$CLASS() { flags|=FLAG_ENABLED|FLAG_SHOWN;}\n"
"$CLASS::~$CLASS() {\n"
"\011int i,j;\n"
"\011for(i=0;i<$NROWS;i++)\n"
"\011\011for(j=0;j<$NCOLS;j++)\n"
"\011\011\011if (cells[i][j].data)\n"
"\011\011\011\011free(cells[i][j].data);\n"
"\n"
"\011$STORAGE_DESTRUCTOR_CODE\n"
"}\n"
"\n"
"$CLASS::$CLASS(FXComposite* p,\n"
"\011\011FXuint opts,\n"
"\011\011FXint x,FXint y,FXint w,FXint h)\n"
"\011: FXScrollArea(p,opts,x,y,w,h)\n"
"{\n"
"\011int i,j;\n"
"\011flags |= FLAG_ENABLED;\n"
"\011myapp= FXApp::instance();\n"
"\011for(i=0;i<$NROWS;i++)\n"
"\011\011for(j=0;j<$NCOLS;j++) {\n"
"\011\011\011cells[i][j].data= 0;\n"
"\011\011\011cells[i][j].cwidth= cells[i][j].cheight= 0;\n"
"\011\011}\n"
"\011$CELL_INIT_CODE\n"
"\n"
"\011for(i=0;i<$NROWS;i++) row_heights[i]= 0;\n"
"\011for(i=0;i<$NCOLS;i++) col_widths[i]= 0;\n"
"\011editor= 0;\n"
"\n"
"\011$STORAGE_INIT_CODE\n"
"\n"
"\011x_pad= 0;\n"
"\011y_pad= 0;\n"
"}\n"
"\n"
"void $CLASS::convert_to_actual_coordinates() {\n"
"\011int i;\n"
"\011int S;\n"
"\011\n"
"\011for(S=0,i=0;i<=$NCOLS;i++) {\n"
"\011\011x_offsets[i]= S;\n"
"\011\011S+= col_widths[i];\n"
"\011}\n"
"\n"
"\011for(S=0,i=0;i<=$NROWS;i++) {\n"
"\011\011y_offsets[i]= S;\n"
"\011\011S+= row_heights[i];\n"
"\011}\n"
"\n"
"\011for(i=0;i<$NHORZLINES;i++) {\n"
"\011\011horz_lines[i].y= y_offsets[horz_line_defs[i].y];\n"
"\011\011horz_lines[i].x1= x_offsets[horz_line_defs[i].x1];\n"
"\011\011horz_lines[i].x2= x_offsets[horz_line_defs[i].x2];\n"
"\011}\n"
"\011for(i=0;i<$NVERTLINES;i++) {\n"
"\011\011vert_lines[i].x= x_offsets[vert_line_defs[i].x];\n"
"\011\011vert_lines[i].y1= y_offsets[vert_line_defs[i].y1];\n"
"\011\011vert_lines[i].y2= y_offsets[vert_line_defs[i].y2];\n"
"\011}\n"
"\011for(i=0;i<$NBGFILLS;i++) {\n"
"\011\011const bgfill_def_t *D;\n"
"\011\011bgfill_act_t *A;\n"
"\011\011D= bgfill_defs + i;\n"
"\011\011A= bgfills+i;\n"
"\011\011A->color= rgb24tofxcolor(D->color);\n"
"\011\011A->area.x1= x_offsets[D->area.x1];\n"
"\011\011A->area.y1= y_offsets[D->area.y1];\n"
"\011\011A->area.x2= x_offsets[D->area.x2];\n"
"\011\011A->area.y2= y_offsets[D->area.y2];\n"
"\011}\n"
"}\n"
"\n"
"\n"
"FXColor $CLASS::rgb24tofxcolor(unsigned int x) {\n"
"\011unsigned int r,g,b;\n"
"\011r= (x>>16)&0xff;\n"
"\011g= (x>>8) & 0xff;\n"
"\011b= (x)&0xff;\n"
"\011return FXRGB(r,g,b);\n"
"}\n"
"\n"
"void $CLASS::get_text_size(int bold,char *data, int *w,int *h)\n"
"{\n"
"\011FXFont *font;\n"
"\011char *x;\n"
"\011int W=0;\n"
"\011int H= 0;\n"
"\011int tw,th;\n"
"\n"
"\011*w=0; *h= 0;\n"
"\011font= bold ? header_font : data_font;\n"
"\011if (!data || !data[0]) return ;\n"
"\011\n"
"\011while((x=strchr(data,\047\134n\047))) {\n"
"\011\011x[0]= 0;\n"
"\011\011get_single_line_text_size(font, data, &tw, &th);\n"
"\011\011x[0]= \047\134n\047;\n"
"\011\011H+= th;\n"
"\011\011if (tw>W) W= tw;\n"
"\011\011data= x+1;\n"
"\011}\n"
"\n"
"\011if (*data) {\n"
"\011\011get_single_line_text_size(font, data, &tw, &th);\n"
"\011\011H+= th;\n"
"\011\011if (tw>W) W= tw;\n"
"\011}\n"
"\n"
"\011*w= W;\n"
"\011*h= H;\n"
"}\n"
"\n"
"void $CLASS::get_single_line_text_size\n"
"\011(FXFont* font,char*data,int *tw,int *th)\n"
"{\n"
"\011*tw= font->getTextWidth(data);\n"
"\011*th= font->getFontHeight();\n"
"}\n"
"\n"
"void $CLASS::render_text\n"
"\011(FXDC* dc,crect_t area, int valign,int halign, int bold,\n"
"\011char *data,int content_width,int content_height)\n"
"{\n"
"\011int X,Y;\n"
"\011char *L;\n"
"\011FXFont* font;\n"
"\n"
"\011if (!data || !data[0]) return ;\n"
"\011font= bold ? header_font : data_font;\n"
"\n"
"\011X= area.x1;\n"
"\011Y= area.y1;\n"
"\011switch(valign) {\n"
"\011\011case valign_top: break;\n"
"\011\011case valign_bottom:\n"
"\011\011\011Y= area.y2- content_height;\n"
"\011\011\011break;\n"
"\011\011case valign_center:\n"
"\011\011\011Y= (area.y1+area.y2-content_height)/2;\n"
"\011\011\011break;\n"
"\011}\n"
"\011while((L=strchr(data,\047\134n\047))) {\n"
"\011\011L[0]= 0;\n"
"\011\011Y= render_text_line(dc,font,X, Y,\n"
"\011\011\011\011halign, data,area.x2-area.x1);\n"
"\011\011data= L+1;\n"
"\011\011L[0]= \047\134n\047;\n"
"\011}\n"
"\011if (data[0])\n"
"\011\011render_text_line(dc,font,X, Y,\n"
"\011\011\011\011halign, data,area.x2-area.x1);\n"
"}\n"
"\n"
"\n"
"\n"
"int $CLASS::render_text_line\n"
"\011\011(FXDC* dc,FXFont *font,int X, int Y,\n"
"\011\011int halign, char *data, int avail_w)\n"
"{\n"
"\011switch(halign) {\n"
"\011case halign_left: break;\n"
"\011case halign_right:\n"
"\011\011X= X+avail_w-font->getTextWidth(data); \n"
"\011\011break;\n"
"\011case halign_center:\n"
"\011\011X= X+avail_w/2-font->getTextWidth(data)/2;\n"
"\011\011break;\n"
"\011}\n"
"\011dc->setFont(font);\n"
"\011dc->drawText(x_pad+X+pos_x,\n"
"\011\011y_pad+Y+font->getFontAscent()+pos_y,\n"
"\011\011data, strlen(data));\n"
"\011return Y+font->getFontHeight();\n"
"}\n"
"\n"
"void $CLASS::calculate_cell_geometry(int i,int j) {\n"
"\011switch(cell_defs[i][j].kind) {\n"
"\011case ck_header: \n"
"\011\011get_text_size(1, cells[i][j].data,\n"
"\011\011&cells[i][j].cwidth, &cells[i][j].cheight);\n"
"\011\011break;\n"
"\011case ck_data:\n"
"\011\011if (cells[i][j].data && cells[i][j].data[0]) {\n"
"\011\011\011get_text_size(0, cells[i][j].data,\n"
"\011\011\011&cells[i][j].cwidth, &cells[i][j].cheight);\n"
"\011\011\011break;\n"
"\011\011}\n"
"\011default:\n"
"\011\011cells[i][j].cwidth= 0;\n"
"\011\011cells[i][j].cheight= 0;\n"
"\011}\n"
"}\n"
"\n"
"void $CLASS::calculate_cell_content_geometries()\n"
"{\n"
"\011int i,j;\n"
"\011for(i=0;i<$NROWS;i++)\n"
"\011\011for(j=0;j<$NCOLS;j++)\n"
"\011\011\011calculate_cell_geometry(i,j);\n"
"}\n"
"\n"
"int $CLASS::calculate_row_heights()\n"
"{\n"
"\011int i,j;\n"
"\011int nh[$NROWS];\n"
"\011for(i=0;i<$NROWS;i++) \n"
"\011\011nh[i]= 0;\n"
"\011for(i=0;i<$NROWS;i++) \n"
"\011\011for(j=0;j<$NCOLS;j++)  {\n"
"\011\011\011int k;\n"
"\011\011\011int a;\n"
"\011\011\011if (!cell_defs[i][j].rowspan) continue;\n"
"\011\011\011k= ceil(cells[i][j].cheight,cell_defs[i][j].rowspan);\n"
"\011\011\011for(a=i;a<i+cell_defs[i][j].rowspan;a++)\n"
"\011\011\011\011if (k>nh[a]) nh[a]= k;\n"
"\011\011}\n"
"\011for(i=0;i<$NROWS;i++)\n"
"\011\011if (nh[i]!=row_heights[i]) {\n"
"\011\011\011memcpy(row_heights, nh, sizeof(int)*$NROWS);\n"
"\011\011\011return 1;\n"
"\011\011}\n"
"\011return 0;\n"
"}\n"
"\n"
"int $CLASS::calculate_col_widths()\n"
"{\n"
"\011int i,j;\n"
"\011int nw[$NCOLS];\n"
"\011for(j=0;j<$NCOLS;j++)  \n"
"\011\011nw[j]= 0;\n"
"\n"
"\011for(j=0;j<$NCOLS;j++) \n"
"\011\011for(i=0;i<$NROWS;i++)  {\n"
"\011\011\011int k;\n"
"\011\011\011int a;\n"
"\011\011\011if (!cell_defs[i][j].colspan) continue;\n"
"\011\011\011k= ceil(cells[i][j].cwidth,cell_defs[i][j].colspan);\n"
"\011\011\011for(a=j;a<j+cell_defs[i][j].colspan;a++)\n"
"\011\011\011\011if (k>nw[a]) nw[a]= k;\n"
"\011\011}\n"
"\011for(j=0;j<$NCOLS;j++)  \n"
"\011\011if (nw[j]!=col_widths[j]) {\n"
"\011\011\011memcpy(col_widths, nw, sizeof(int)*$NCOLS);\n"
"\011\011\011return 1;\n"
"\011\011}\n"
"\011return 0;\n"
"}\n"
"\n"
"int $CLASS::ceil(int a,int b) { return (a+b-1)/b; }\n"
"\n"
"int $CLASS::classify_point(crect_t R, int x,int y)\n"
"{\n"
"\011int C;\n"
"\011C= 0;\n"
"\011if (x<R.x1) C|= 1; else if (x>=R.x2) C|=2;\n"
"\011if (y<R.y1) C|=4; else if (y>=R.y2) C|= 8;\n"
"\011return C;\n"
"}\n"
"\n"
"int $CLASS::rectangles_intersect(crect_t R1,crect_t R2)\n"
"{\n"
"\011return (classify_point(R1, R2.x1,R2.y1) &\n"
"\011\011 classify_point(R1, R2.x2,R2.y2))==0;\n"
"}\n"
"\n"
"int $CLASS::xline_visible(crect_t R, xline_t L)\n"
"{\n"
"\011return (classify_point(R, L.x1, L.y) &\n"
"\011\011 classify_point(R, L.x2, L.y))==0;\n"
"}\n"
"\n"
"int $CLASS::yline_visible(crect_t R,yline_t L)\n"
"{\n"
"\011return (classify_point(R, L.x, L.y1) &\n"
"\011\011 classify_point(R, L.x, L.y2))==0;\n"
"}\n"
"\n"
"const $CLASS::xline_t\n"
"$CLASS::horz_line_defs[$NHORZLINES] = {\n"
"\011$HORZ_LINE_DEFS\n"
"};\n"
"const $CLASS::yline_t\n"
"$CLASS::vert_line_defs[$NVERTLINES] = {\n"
"\011$VERT_LINE_DEFS\n"
"};\n"
"\n"
"const $CLASS::bgfill_def_t\n"
"$CLASS::bgfill_defs[$NBGFILLS] = {\n"
"\011$BG_FILL_DEFS\n"
"};\n"
"\n"
"const $CLASS::cell_def_t \n"
"$CLASS::cell_defs[$NROWS][$NCOLS]= {\n"
"\011$CELL_DEFS\n"
"};\n"
"\n"
"\n"
"void $CLASS::set_cell_text_noupdate(int r,int c,char *text) {\n"
"\011if (c<0 || r<0 || c>=$NCOLS || r>=$NROWS) return ;\n"
"\011if (cell_defs[r][c].kind!=ck_data) return ;\n"
"\011if (cells[r][c].data)\n"
"\011\011free(cells[r][c].data);\n"
"\011if (text) text= strdup(text);\n"
"\011cells[r][c].data= text;\n"
"}\n"
"\n"
"void $CLASS::set_cell_text(int r,int c,char *text) {\n"
"\011if (c<0 || r<0 || c>=$NCOLS || r>=$NROWS) return ;\n"
"\011if (cell_defs[r][c].kind!=ck_data) return ;\n"
"\011set_cell_text_noupdate(r,c,text);\n"
"\011calculate_cell_geometry(r,c);\n"
"}\n"
"\n"
"\n"
"void $CLASS::begin_update() {\n"
"}\n"
"\n"
"void $CLASS::end_update() {\n"
"\011if (calculate_col_widths())  {\n"
"\011\011convert_to_actual_coordinates();\n"
"\011\011recalc();\n"
"\011\011layout();\n"
"\011}\n"
"\011update();\n"
"}\n"
"\n"
"\n"
"void $CLASS::boxed_str::init($CLASS *tb,int r,int c) {\n"
"\011value= 0;\n"
"\011table= tb;\n"
"\011row= r;\n"
"\011col= c;\n"
"}\n"
"\n"
"void $CLASS::boxed_str::start_edit() {\n"
"\011table->start_edit(row,col);\n"
"}\n"
"\n"
"\n"
"void $CLASS::boxed_int::start_edit() {\n"
"\011table->start_edit(row,col);\n"
"}\n"
"\n"
"void $CLASS::boxed_int::init($CLASS *tb,int r,int c) {\n"
"\011value= 0;\n"
"\011table= tb;\n"
"\011row= r;\n"
"\011col= c;\n"
"}\n"
"\n"
"void $CLASS::boxed_int::set(int v) {\n"
"\011char *tmp;\n"
"\011value = v;\n"
"\011if (value || table->show_if_zero(row,col)) {\n"
"\011\011tmp= table->format_int(v,\n"
"\011\011\011table->cell_defs[row][col].format);\n"
"\011\011table->set_cell_text(row,col,tmp);\n"
"\011\011free(tmp);\n"
"\011} else table->set_cell_text(row,col,0);\n"
"}\n"
"\n"
"void $CLASS::boxed_str::set(char *v) {\n"
"\011if (value)\n"
"\011\011free(value);\n"
"\011if (v && v[0]) \n"
"\011\011value= strdup(v);\n"
"\011else\n"
"\011\011value= 0;\n"
"\011table->set_cell_text(row,col,value);\n"
"}\n"
"\n"
"char* $CLASS::format_int(int v,const char *fmt)\n"
"{\n"
"\011size_t ndigits;\n"
"\011char buf[200];\n"
"\011int i;\n"
"\011char *D;\n"
"\011char *x;\n"
"\011char *b;\n"
"\011size_t L;\n"
"\n"
"\011sprintf(buf,\042%d\042,v);\n"
"\011if (!fmt || !fmt[0])\n"
"\011\011return strdup(buf);\n"
"\n"
"\011ndigits= 0;\n"
"\011for(i=0;fmt[i];i++)\n"
"\011\011if (fmt[i]==\047#\047) ndigits++;\n"
"\n"
"\011L=  (ndigits>strlen(buf) ? ndigits : strlen(buf)) +\n"
"\011\011strlen(fmt)-ndigits + 1;\n"
"\011D= (char*) malloc(L);\n"
"\011x= D+L-1;\n"
"\011x[0]= 0;\n"
"\011x--;\n"
"\011b= buf+strlen(buf)-1;\n"
"\n"
"\011for(i=strlen(fmt)-1;i>=0;i--) {\n"
"\011\011if (fmt[i]==\047#\047) {\n"
"\011\011\011if (b<buf) *x= \0470\047;\n"
"\011\011\011else {\n"
"\011\011\011\011*x= *b;\n"
"\011\011\011\011b--;\n"
"\011\011\011}\n"
"\011\011\011x--;\n"
"\011\011} else {\n"
"\011\011\011*x= fmt[i];\n"
"\011\011\011x--;\n"
"\011\011}\n"
"\011}\n"
"\n"
"\011while(b>=buf) {\n"
"\011\011*x= *b;\n"
"\011\011x--; b--;\n"
"\011}\n"
"\011return D;\n"
"}\n"
"\n"
"char *$CLASS::format_str(char *v,const char* fmt)\n"
"{\n"
"\011if (v)\n"
"\011\011return strdup(v);\n"
"\011else\n"
"\011\011return 0;\n"
"}\n"
"\n"
"char *$CLASS::unformat_str(char *v,const char* fmt)\n"
"{\n"
"\011if (v)\n"
"\011\011return strdup(v);\n"
"\011else\n"
"\011\011return 0;\n"
"}\n"
"\n"
"int $CLASS::unformat_int(char *x,const char*fmt)\n"
"{\n"
"\011int i;\n"
"\011int j;\n"
"\011if (!x) return 0;\n"
"\011x= strdup(x);\n"
"\011j= 0;\n"
"\011for(i=0;x[i];i++)\n"
"\011\011if ((x[i]>=\0470\047 && x[i]<=\0479\047) || (j==0 && x[i]==\047-\047))\n"
"\011\011\011x[j++]= x[i];\n"
"\011x[j]= 0;\n"
"\011i= atoi(x);\n"
"\011free(x);\n"
"\011return i;\n"
"}\n"
"\n"
"$CLASS::raw_storage_t* $CLASS::parse_data\n"
"\011(char *buf,size_t len)\n"
"{\n"
"\011char **B;\n"
"\011size_t *L;\n"
"\011raw_storage_t* obj;\n"
"\011obj= (raw_storage_t*) malloc(sizeof(*obj));\n"
"\011B= &buf;\n"
"\011L= &len;\n"
"\n"
"\011$RAW_PARSING_CODE\n"
"\011return obj;\n"
"}\n"
"\n"
"void $CLASS::destroy_data($CLASS::raw_storage_t *obj) {\n"
"\011$RAW_DESTRUCTOR\n"
"\011free(obj);\n"
"}\n"
"\n"

    ;  // end of source code



static void print_code_with_subs (char *fn, char *code, strpairlist_t *subs)
{
	FILE *f;
	f= fopen(fn,"w");
	if (!f)
		exit(fprintf(stderr,"can not open %s for writing: %s\n",
			fn, strerror(errno)));
	code= do_replacements(code, subs);
	fwrite(code, 1, strlen(code), f);
	fclose(f);
}


void print_code (char *sn,strpairlist_t *subs)
{
	char buf[2000];
	sprintf(buf,"%s.cc", sn);
	print_code_with_subs(buf,source_code, subs);
	sprintf(buf,"%s.h", sn);
	print_code_with_subs(buf,header_code, subs);
}



