/*

Copyright (c) 2009 Şükrü Çınar  (sukru cinar)

This program is distributed under GNU GPL v2. See file COPYING
for licensing details.

*/

#ifndef DECL_DOT_H_INCLUDED
#define DECL_DOT_H_INCLUDED

enum celltype
{ typ_int, typ_str };
typedef struct
{
  char *name;
  int editable;
  enum celltype type;
  char *format;
  int show_if_zero;
} decl_t;
struct declist_t_NODE
{
  struct declist_t_NODE *prev, *next;
  decl_t *data;
};
typedef struct
{
  struct declist_t_NODE head;
} declist_t;
#ifdef __cplusplus
extern "C"
{
#endif
  void declist_init (declist_t * L);
  decl_t *declist_destroy (declist_t * L);
  declist_t *declist_new ();
  void declist_append (declist_t * L, decl_t * data);
  void declist_prepend (declist_t * L, decl_t * data);
  void declist_remove (declist_t * L, struct declist_t_NODE *n);
  int declist_isempty (declist_t * L);
  declist_t *parse_declarations (grid_t * G);
#ifdef __cplusplus
}
#endif

#endif
