/*

Copyright (c) 2009 Şükrü Çınar  (sukru cinar)

This program is distributed under GNU GPL v2. See file COPYING
for licensing details.

*/

#ifndef FIELD_DOT_H_INCLUDED
#define FIELD_DOT_H_INCLUDED

typedef enum
{ field_single, field_sarray,
  field_array, field_2darray
} field_kind_t;
typedef struct
{
  int r, c;
} cellref_t;
struct cellreflist_t_NODE
{
  struct cellreflist_t_NODE *prev, *next;
  cellref_t *data;
};
typedef struct
{
  struct cellreflist_t_NODE head;
} cellreflist_t;
typedef struct
{
  char *name;
  char *format;
  enum celltype type;
  field_kind_t kind;
  int r1, c1;
  int r2, c2;
  int dim1;
  int dim2;
  cellreflist_t *cells;
  int editable;
  int show_if_zero;
} field_t;
struct fieldlist_t_NODE
{
  struct fieldlist_t_NODE *prev, *next;
  field_t *data;
};
typedef struct
{
  struct fieldlist_t_NODE head;
} fieldlist_t;
typedef struct
{
  field_t *field;
  int idx1, idx2;
} fieldref_t;
typedef struct
{
  fieldlist_t *fields;
  int nrows, ncols;
  fieldref_t **field_map;
} storage_t;
#ifdef __cplusplus
extern "C"
{
#endif
  void cellreflist_init (cellreflist_t * L);
  cellref_t *cellreflist_destroy (cellreflist_t * L);
  cellreflist_t *cellreflist_new ();
  void cellreflist_append (cellreflist_t * L, cellref_t * data);
  void cellreflist_prepend (cellreflist_t * L, cellref_t * data);
  void cellreflist_remove (cellreflist_t * L, struct cellreflist_t_NODE *n);
  int cellreflist_isempty (cellreflist_t * L);
  void fieldlist_init (fieldlist_t * L);
  field_t *fieldlist_destroy (fieldlist_t * L);
  fieldlist_t *fieldlist_new ();
  void fieldlist_append (fieldlist_t * L, field_t * data);
  void fieldlist_prepend (fieldlist_t * L, field_t * data);
  void fieldlist_remove (fieldlist_t * L, struct fieldlist_t_NODE *n);
  int fieldlist_isempty (fieldlist_t * L);
  storage_t *compute_fields
    (grid_t * layout, declist_t * decs, strpairlist_t * vars);
#ifdef __cplusplus
}
#endif

#endif
