/*

Copyright (c) 2009 Şükrü Çınar  (sukru cinar)

This program is distributed under GNU GPL v2. See file COPYING
for licensing details.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "parsedoc.h"
#include "style.h"
#include "repstr.h"
#include "genlines.h"
#include "part.h"
#include "decl.h"
#include "field.h"
#include "gencells.h"
#include "code.h"
#include "serialize.h"

static void add_simple_variables (sheet_t * S, grid_t * G, strpairlist_t * V);
static char *output_file_name;

void *__unused_fixtable_c[] = {

  0,
};

int
main ()
{
  doc_t *D;
  sheet_t *S;
  grid_t *G;
  declist_t *decls;
  strpairlist_t *V;
  storage_t *storage;

  V = strpairlist_new ();

  D = parse_doc (stdin);
  if (sheetlist_isempty (D->sheets))
    exit (fprintf (stderr, "no sheets in document!\n"));
  S = sheetlist_destroy (D->sheets);
  G = apply_styles (S);
  if (sheetlist_isempty (D->sheets))
    exit (fprintf (stderr, "no declaration sheet in document\n"));

  decls = parse_declarations (apply_styles (sheetlist_destroy (D->sheets)));
  storage = compute_fields (G, decls, V);

  gen_lines (G, V);
  partition_bgfills (G, V);
  gen_cells (G, storage, V);

  add_simple_variables (S, G, V);

  output_serialization_code (storage, V);

/*	strpairlist_dump(V);*/
  print_code (output_file_name, V);

  return 0;
}

static void add_simple_variables (sheet_t * S, grid_t * G, strpairlist_t * V)
{
  char *name;
  int i;
  char buf[200];
  strpairlist_append (V, strpair_new (strdup ("$CLASS"), strdup (S->name)));
  sprintf (buf, "%d", G->ncols);
  strpairlist_append (V, strpair_new (strdup ("$NCOLS"), strdup (buf)));
  sprintf (buf, "%d", G->nrows);
  strpairlist_append (V, strpair_new (strdup ("$NROWS"), strdup (buf)));
  name = S->name;
  for (i = 0; name[i]; i++)
    name[i] = tolower (name[i]);
  strpairlist_append (V, strpair_new (strdup ("$FILENAME"), name));

  output_file_name = name;
}
