/*

Copyright (c) 2009 Şükrü Çınar  (sukru cinar)

This program is distributed under GNU GPL v2. See file COPYING
for licensing details.

*/

#ifndef MISCFN_DOT_H_INCLUDED
#define MISCFN_DOT_H_INCLUDED

#include <stdarg.h>
typedef struct
{
  struct cbuffer_t_node *first;
  struct cbuffer_t_node *last;
} cbuffer_t;
#ifdef __cplusplus
extern "C"
{
#endif
  void cbuffer_init (cbuffer_t * B);
  cbuffer_t *cbuffer_new ();
  void cbuffer_append (cbuffer_t * B, char D);
  char *cbuffer_collect (cbuffer_t * B, int *size);
  char *cbuffer_collectd (cbuffer_t * B, int *size);
  char *cbuffer_collectda (cbuffer_t * B, int *size);
  void cbuffer_destroy (cbuffer_t * B);
  void cbuffer_destroya (cbuffer_t * B);
  void cbuffer_putstr (cbuffer_t * cb, char *xb);
  size_t vgenprintf (void (*write) (void *arg, const char *buf, size_t len),
		     void *arg, const char *fmt, va_list args);
  size_t genprintf (void (*write) (void *arg, const char *buf, size_t len),
		    void *arg, const char *fmt, ...);
  size_t fdprintf (int fd, const char *fmt, ...);
  char *vmprintf (const char *fmt, va_list ap);
  size_t vnprintf (const char *fmt, va_list ap);
  char *mprintf (const char *fmt, ...);
  void cbprintf (cbuffer_t * cb, char *fmt, ...);
  void remove_spaces (char *data);
#ifdef __cplusplus
}
#endif

#endif
