/*

Copyright (c) 2009 Şükrü Çınar  (sukru cinar)

This program is distributed under GNU GPL v2. See file COPYING
for licensing details.

*/

#include <stdlib.h>
#include <sys/types.h>
#include <regex.h>
#include <string.h>
#include <stdio.h>

#include <stdio.h>
#include <expat.h>

#include <stdio.h>
#include <expat.h>
#include <string.h>

#include "parsedoc.h"
typedef struct pnode pnode_t;
struct pnodelist_t_NODE
{
  struct pnodelist_t_NODE *prev, *next;
  pnode_t *data;
};
typedef struct
{
  struct pnodelist_t_NODE head;
} pnodelist_t;
struct pnode
{
  char *name;
  char **(*func) (void *, char *, char **);
  pnodelist_t *children;
  pnode_t *parent;
};
typedef struct
{
  int nelts;
  int size;
  pnode_t **elts;
} pstack_t;
typedef struct
{
  int nelts;
  int size;
  char ***elts;
} sstack_t;
typedef struct
{
  XML_Parser xparser;
  pstack_t *stack;
  sstack_t *sstack;
  void *udata;
} pstate_t;
static void pnodelist_init (pnodelist_t * L);
static pnode_t *pnodelist_destroy (pnodelist_t * L);
static pnodelist_t *pnodelist_new ();
static void pnodelist_append (pnodelist_t * L, pnode_t * data);
static void pnodelist_prepend (pnodelist_t * L, pnode_t * data);
static void pnodelist_remove (pnodelist_t * L, struct pnodelist_t_NODE *n);
static int pnodelist_isempty (pnodelist_t * L);
static pstack_t *pstack_new ();
static void pstack_init (pstack_t * L);
static pnode_t *pstack_pop (pstack_t * L);
static void pstack_push (pstack_t * L, pnode_t * d);
static pstack_t *pstack_destroy (pstack_t * L);
static int pstack_isempty (pstack_t * L);
static sstack_t *sstack_new ();
static void sstack_init (sstack_t * L);
static char **sstack_pop (sstack_t * L);
static void sstack_push (sstack_t * L, char **d);
static sstack_t *sstack_destroy (sstack_t * L);
static int sstack_isempty (sstack_t * L);
static void startElement
  (void *userData, const char *name, const char **attr);
static void endElement (void *userData, const char *name);
static void parse_xml (FILE * f, pnode_t * top, void *udata);
static pnode_t *pn_new (char *name, char **(*func) (void *, char *, char **));
static void characterData (void *udata, const char *s, int len);
static void pnode_print (pnode_t * P);
static int get_int_attrib (char **attr, char *name);
static int get_color_attrib (char **attr, char *name);
static int phex (char *x);
static char *get_str_attrib (char **attr, char *name);
static char **strsplit (char *re, char *d);
static char *collect_substr (char *str, int len);
static sheet_t *csheet;
static styleregion_t *cstyle;

static char **pf_15 (void *udata, char *name, char **attr)
{

  return 0;

}

static char **pf_16 (void *udata, char *name, char **attr)
{

  return 0;

}

static char **pf_17 (void *udata, char *name, char **attr)
{

  doc_t *D = udata;

  csheet = (typeof (csheet)) calloc (1, sizeof (csheet[0]));

  csheet->cells = cellist_new ();
  csheet->styleregions = styleregionlist_new ();
  csheet->merges = mergelist_new ();
  sheetlist_append (D->sheets, csheet);
  return 0;

}

static char **pf_20 (void *udata, char *name, char **attr)
{

  return &csheet->name;

}

static char **pf_22 (void *udata, char *name, char **attr)
{

  return &csheet->maxrow;

}

static char **pf_24 (void *udata, char *name, char **attr)
{

  return &csheet->maxcol;

}

static char **pf_26 (void *udata, char *name, char **attr)
{

  return 0;

}

static char **pf_27 (void *udata, char *name, char **attr)
{

  styleregion_t *S;

  S = (typeof (S)) calloc (1, sizeof (S[0]));

  styleregionlist_append (csheet->styleregions, S);

  cstyle = S;
  S->startCol = get_int_attrib (attr, "startCol");
  S->startRow = get_int_attrib (attr, "startRow");
  S->endCol = get_int_attrib (attr, "endCol");
  S->endRow = get_int_attrib (attr, "endRow");
  return 0;

}

static char **pf_30 (void *udata, char *name, char **attr)
{

  cstyle->hAlign = get_int_attrib (attr, "HAlign");
  cstyle->vAlign = get_int_attrib (attr, "VAlign");
  cstyle->fgcolor = get_color_attrib (attr, "Fore");
  cstyle->bgcolor = get_color_attrib (attr, "Back");
  return 0;

}

static char **pf_31 (void *udata, char *name, char **attr)
{

  cstyle->bold = get_int_attrib (attr, "Bold");
  return 0;

}

static char **pf_33 (void *udata, char *name, char **attr)
{

  return 0;

}

static char **pf_34 (void *udata, char *name, char **attr)
{

  cstyle->bTop = 1;
  return 0;

}

static char **pf_36 (void *udata, char *name, char **attr)
{

  cstyle->bLeft = 1;
  return 0;

}

static char **pf_38 (void *udata, char *name, char **attr)
{

  cstyle->bRight = 1;
  return 0;

}

static char **pf_40 (void *udata, char *name, char **attr)
{

  cstyle->bBottom = 1;
  return 0;

}

static char **pf_46 (void *udata, char *name, char **attr)
{

  return 0;

}

static char **pf_47 (void *udata, char *name, char **attr)
{

  cell_t *C;

  C = (typeof (C)) calloc (1, sizeof (C[0]));

  C->row = get_int_attrib (attr, "Row");
  C->col = get_int_attrib (attr, "Col");
  cellist_append (csheet->cells, C);
  return &C->data;

}

static char **pf_51 (void *udata, char *name, char **attr)
{

  return 0;

}

static char **pf_52 (void *udata, char *name, char **attr)
{

  merge_t *M;

  M = (typeof (M)) calloc (1, sizeof (M[0]));

  mergelist_append (csheet->merges, M);
  return &M->data;

}

void *__unused_parsedoc_c[] = {

  (void *) pnodelist_init,

  (void *) pnodelist_destroy,

  (void *) pnodelist_prepend,

  (void *) pnodelist_isempty,

  (void *) pstack_init,

  (void *) pstack_destroy,

  (void *) pstack_isempty,

  (void *) sstack_init,

  (void *) sstack_destroy,

  (void *) sstack_isempty,

  0,
};

void cellist_init (cellist_t * L)
{
  L->head.prev = L->head.next = &L->head;
}

cell_t *cellist_destroy (cellist_t * L)
{
  typeof (L->head.next) N;
  cell_t *R;

  N = L->head.next;
  if (N == &L->head)
    return 0;
  R = N->data;

  cellist_remove (L, N);
  return R;
}

cellist_t *cellist_new ()
{
  cellist_t *L;
  L = (typeof (L)) malloc (sizeof (*L));
  L->head.prev = L->head.next = &L->head;
  return L;
}

void cellist_append (cellist_t * L, cell_t * data)
{
  struct cellist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->prev = L->head.prev;
  n->next = &L->head;
  L->head.prev->next = n;
  L->head.prev = n;
}

void cellist_prepend (cellist_t * L, cell_t * data)
{
  struct cellist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->next = L->head.next;
  n->prev = &L->head;
  L->head.next->prev = n;
  L->head.next = n;
}

void cellist_remove (cellist_t * L, struct cellist_t_NODE *n)
{
  n->prev->next = n->next;
  n->next->prev = n->prev;
  free (n);
}

int cellist_isempty (cellist_t * L)
{
  return L->head.next == &L->head;
}

void mergelist_init (mergelist_t * L)
{
  L->head.prev = L->head.next = &L->head;
}

merge_t *mergelist_destroy (mergelist_t * L)
{
  typeof (L->head.next) N;
  merge_t *R;

  N = L->head.next;
  if (N == &L->head)
    return 0;
  R = N->data;

  mergelist_remove (L, N);
  return R;
}

mergelist_t *mergelist_new ()
{
  mergelist_t *L;
  L = (typeof (L)) malloc (sizeof (*L));
  L->head.prev = L->head.next = &L->head;
  return L;
}

void mergelist_append (mergelist_t * L, merge_t * data)
{
  struct mergelist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->prev = L->head.prev;
  n->next = &L->head;
  L->head.prev->next = n;
  L->head.prev = n;
}

void mergelist_prepend (mergelist_t * L, merge_t * data)
{
  struct mergelist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->next = L->head.next;
  n->prev = &L->head;
  L->head.next->prev = n;
  L->head.next = n;
}

void mergelist_remove (mergelist_t * L, struct mergelist_t_NODE *n)
{
  n->prev->next = n->next;
  n->next->prev = n->prev;
  free (n);
}

int mergelist_isempty (mergelist_t * L)
{
  return L->head.next == &L->head;
}

void styleregionlist_init (styleregionlist_t * L)
{
  L->head.prev = L->head.next = &L->head;
}

styleregion_t *styleregionlist_destroy (styleregionlist_t * L)
{
  typeof (L->head.next) N;
  styleregion_t *R;

  N = L->head.next;
  if (N == &L->head)
    return 0;
  R = N->data;

  styleregionlist_remove (L, N);
  return R;
}

styleregionlist_t *styleregionlist_new ()
{
  styleregionlist_t *L;
  L = (typeof (L)) malloc (sizeof (*L));
  L->head.prev = L->head.next = &L->head;
  return L;
}

void styleregionlist_append (styleregionlist_t * L, styleregion_t * data)
{
  struct styleregionlist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->prev = L->head.prev;
  n->next = &L->head;
  L->head.prev->next = n;
  L->head.prev = n;
}

void styleregionlist_prepend (styleregionlist_t * L, styleregion_t * data)
{
  struct styleregionlist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->next = L->head.next;
  n->prev = &L->head;
  L->head.next->prev = n;
  L->head.next = n;
}

void
  styleregionlist_remove
  (styleregionlist_t * L, struct styleregionlist_t_NODE *n)
{
  n->prev->next = n->next;
  n->next->prev = n->prev;
  free (n);
}

int styleregionlist_isempty (styleregionlist_t * L)
{
  return L->head.next == &L->head;
}

void sheetlist_init (sheetlist_t * L)
{
  L->head.prev = L->head.next = &L->head;
}

sheet_t *sheetlist_destroy (sheetlist_t * L)
{
  typeof (L->head.next) N;
  sheet_t *R;

  N = L->head.next;
  if (N == &L->head)
    return 0;
  R = N->data;

  sheetlist_remove (L, N);
  return R;
}

sheetlist_t *sheetlist_new ()
{
  sheetlist_t *L;
  L = (typeof (L)) malloc (sizeof (*L));
  L->head.prev = L->head.next = &L->head;
  return L;
}

void sheetlist_append (sheetlist_t * L, sheet_t * data)
{
  struct sheetlist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->prev = L->head.prev;
  n->next = &L->head;
  L->head.prev->next = n;
  L->head.prev = n;
}

void sheetlist_prepend (sheetlist_t * L, sheet_t * data)
{
  struct sheetlist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->next = L->head.next;
  n->prev = &L->head;
  L->head.next->prev = n;
  L->head.next = n;
}

void sheetlist_remove (sheetlist_t * L, struct sheetlist_t_NODE *n)
{
  n->prev->next = n->next;
  n->next->prev = n->prev;
  free (n);
}

int sheetlist_isempty (sheetlist_t * L)
{
  return L->head.next == &L->head;
}

doc_t *
parse_doc (FILE * f)
{
  doc_t *doc;

  pnode_t *P;

  {
    pnode_t *parent;
    P = pn_new (0, 0);
    P->children = pnodelist_new ();
    parent = P;

    pnode_t *F15;
    F15 = pn_new ("gnm:Workbook", pf_15);
    F15->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F15);
      }
    parent = F15;

    pnode_t *F16;
    F16 = pn_new ("gnm:Sheets", pf_16);
    F16->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F16);
      }
    parent = F16;

    pnode_t *F17;
    F17 = pn_new ("gnm:Sheet", pf_17);
    F17->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F17);
      }
    parent = F17;

    pnode_t *F20;
    F20 = pn_new ("gnm:Name", pf_20);
    F20->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F20);
      }
    parent = F20;

    parent = F20->parent;

    pnode_t *F22;
    F22 = pn_new ("gnm:MaxRow", pf_22);
    F22->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F22);
      }
    parent = F22;

    parent = F22->parent;

    pnode_t *F24;
    F24 = pn_new ("gnm:MaxCol", pf_24);
    F24->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F24);
      }
    parent = F24;

    parent = F24->parent;

    pnode_t *F26;
    F26 = pn_new ("gnm:Styles", pf_26);
    F26->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F26);
      }
    parent = F26;

    pnode_t *F27;
    F27 = pn_new ("gnm:StyleRegion", pf_27);
    F27->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F27);
      }
    parent = F27;

    pnode_t *F30;
    F30 = pn_new ("gnm:Style", pf_30);
    F30->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F30);
      }
    parent = F30;

    pnode_t *F31;
    F31 = pn_new ("gnm:Font", pf_31);
    F31->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F31);
      }
    parent = F31;

    parent = F31->parent;

    pnode_t *F33;
    F33 = pn_new ("gnm:StyleBorder", pf_33);
    F33->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F33);
      }
    parent = F33;

    pnode_t *F34;
    F34 = pn_new ("gnm:Top", pf_34);
    F34->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F34);
      }
    parent = F34;

    parent = F34->parent;

    pnode_t *F36;
    F36 = pn_new ("gnm:Left", pf_36);
    F36->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F36);
      }
    parent = F36;

    parent = F36->parent;

    pnode_t *F38;
    F38 = pn_new ("gnm:Right", pf_38);
    F38->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F38);
      }
    parent = F38;

    parent = F38->parent;

    pnode_t *F40;
    F40 = pn_new ("gnm:Bottom", pf_40);
    F40->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F40);
      }
    parent = F40;

    parent = F40->parent;

    parent = F33->parent;

    parent = F30->parent;

    parent = F27->parent;

    parent = F26->parent;

    pnode_t *F46;
    F46 = pn_new ("gnm:Cells", pf_46);
    F46->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F46);
      }
    parent = F46;

    pnode_t *F47;
    F47 = pn_new ("gnm:Cell", pf_47);
    F47->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F47);
      }
    parent = F47;

    parent = F47->parent;

    parent = F46->parent;

    pnode_t *F51;
    F51 = pn_new ("gnm:MergedRegions", pf_51);
    F51->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F51);
      }
    parent = F51;

    pnode_t *F52;
    F52 = pn_new ("gnm:Merge", pf_52);
    F52->parent = parent;
    if (parent)
      {
	if (!parent->children)
	  parent->children = pnodelist_new ();
	pnodelist_append (parent->children, F52);
      }
    parent = F52;

    parent = F52->parent;

    parent = F51->parent;

    parent = F17->parent;

    parent = F16->parent;

    parent = F15->parent;

  }

  doc = (typeof (doc)) calloc (1, sizeof (doc[0]));

  doc->sheets = sheetlist_new ();

#if 0
  printf ("PARSE TREE\n");
  pnode_print (P);
  printf ("END PARSE TREE\n");
#endif

  parse_xml (f, P, doc);
  return doc;
}

static void pnodelist_init (pnodelist_t * L)
{
  L->head.prev = L->head.next = &L->head;
}

static pnode_t *pnodelist_destroy (pnodelist_t * L)
{
  typeof (L->head.next) N;
  pnode_t *R;

  N = L->head.next;
  if (N == &L->head)
    return 0;
  R = N->data;

  pnodelist_remove (L, N);
  return R;
}

static pnodelist_t *pnodelist_new ()
{
  pnodelist_t *L;
  L = (typeof (L)) malloc (sizeof (*L));
  L->head.prev = L->head.next = &L->head;
  return L;
}

static void pnodelist_append (pnodelist_t * L, pnode_t * data)
{
  struct pnodelist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->prev = L->head.prev;
  n->next = &L->head;
  L->head.prev->next = n;
  L->head.prev = n;
}

static void pnodelist_prepend (pnodelist_t * L, pnode_t * data)
{
  struct pnodelist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->next = L->head.next;
  n->prev = &L->head;
  L->head.next->prev = n;
  L->head.next = n;
}

static void pnodelist_remove (pnodelist_t * L, struct pnodelist_t_NODE *n)
{
  n->prev->next = n->next;
  n->next->prev = n->prev;
  free (n);
}

static int pnodelist_isempty (pnodelist_t * L)
{
  return L->head.next == &L->head;
}

static pstack_t *pstack_new ()
{
  pstack_t *L;
  L = malloc (sizeof (*L));
  L->nelts = 0;
  L->size = 0;
  L->elts = 0;
  return L;
}

static void pstack_init (pstack_t * L)
{
  L->nelts = 0;
  L->size = 0;
  L->elts = 0;
}

static pnode_t *pstack_pop (pstack_t * L)
{
  pnode_t *R;
  L->nelts--;
  R = L->elts[L->nelts];
  return R;
}

static void pstack_push (pstack_t * L, pnode_t * d)
{
  if (L->nelts == L->size)
    {
      if (!L->size)
	{
	  L->size = 20;
	  L->elts = calloc (L->size, sizeof (pnode_t *));
	}
      else
	{
	  L->size += L->size / 2;
	  L->elts = realloc (L->elts, L->size * sizeof (pnode_t *));
	}
    }
  L->elts[L->nelts] = d;
  L->nelts++;
}

static pstack_t *pstack_destroy (pstack_t * L)
{
  if (L->size)
    free (L->elts);
  L->size = 0;
  return L;
}

static int pstack_isempty (pstack_t * L)
{
  return L->nelts == 0;
}

static sstack_t *sstack_new ()
{
  sstack_t *L;
  L = malloc (sizeof (*L));
  L->nelts = 0;
  L->size = 0;
  L->elts = 0;
  return L;
}

static void sstack_init (sstack_t * L)
{
  L->nelts = 0;
  L->size = 0;
  L->elts = 0;
}

static char **sstack_pop (sstack_t * L)
{
  char **R;
  L->nelts--;
  R = L->elts[L->nelts];
  return R;
}

static void sstack_push (sstack_t * L, char **d)
{
  if (L->nelts == L->size)
    {
      if (!L->size)
	{
	  L->size = 20;
	  L->elts = calloc (L->size, sizeof (char **));
	}
      else
	{
	  L->size += L->size / 2;
	  L->elts = realloc (L->elts, L->size * sizeof (char **));
	}
    }
  L->elts[L->nelts] = d;
  L->nelts++;
}

static sstack_t *sstack_destroy (sstack_t * L)
{
  if (L->size)
    free (L->elts);
  L->size = 0;
  return L;
}

static int sstack_isempty (sstack_t * L)
{
  return L->nelts == 0;
}

static void startElement (void *userData, const char *name, const char **attr)
{
  pstate_t *S = userData;
  pnode_t *P;

  P = pstack_pop (S->stack);
  pstack_push (S->stack, P);
  if (!P || !P->children)
    goto notfound;
  {
    typeof ((*P->children).head.next) N161, T161;
    for (T161 = (*P->children).head.next;
	 T161 != &((*P->children).head); T161 = N161)
      {
	typeof (T161->data) K;
	K = T161->data;
	N161 = T161->next;

	if (!strcmp (K->name, name))
	  {
	    pstack_push (S->stack, K);
	    if (K->func)
	      sstack_push (S->sstack,
			   K->func (S->udata, (char *) name, (char **) attr));
	    else
	      sstack_push (S->sstack, 0);
	    return;
	  }

      }
  }

notfound:
  pstack_push (S->stack, 0);
  sstack_push (S->sstack, 0);
}

static void endElement (void *userData, const char *name)
{
  pstate_t *S = userData;
  pstack_pop (S->stack);
  sstack_pop (S->sstack);
}

static void
parse_xml (FILE * f, pnode_t * top, void *udata)
{
  char buf[2000];
  XML_Parser parser;
  pstate_t state;

  parser = XML_ParserCreate (NULL);
  state.xparser = parser;
  state.stack = pstack_new ();
  state.sstack = sstack_new ();
  state.udata = udata;
  XML_SetUserData (parser, &state);
  XML_SetElementHandler (parser, startElement, endElement);
  XML_SetCharacterDataHandler (parser, characterData);
  pstack_push (state.stack, top);
  sstack_push (state.sstack, 0);

  while (1)
    {
      size_t len;
      len = fread (buf, 1, sizeof (buf), f);
      if (len <= 0)
	{
	  if (feof (f))
	    {
	      if (!XML_Parse (parser, buf, 0, 1))
		goto prt_err;
	      break;
	    }
	  else
	    {
	      goto prt_err;
	    }
	}
      if (!XML_Parse (parser, buf, len, 0))
	goto prt_err;
    }
  XML_ParserFree (parser);
  return;
prt_err:
  fprintf (stderr,
	   "%s at line %d\n",
	   XML_ErrorString (XML_GetErrorCode (parser)),
	   (int) XML_GetCurrentLineNumber (parser));
  exit (1);
  return;
}

static pnode_t *pn_new (char *name, char **(*func) (void *, char *, char **))
{
  pnode_t *P;

  P = (typeof (P)) calloc (1, sizeof (P[0]));

  if (name)
    P->name = strdup (name);
  P->func = func;
  return P;
}

static void characterData (void *udata, const char *s, int len)
{
  pstate_t *S = udata;
  char **D;
  D = sstack_pop (S->sstack);
  sstack_push (S->sstack, D);
  if (D)
    {
      char *C, *K;
      C = *D;
      if (C)
	{
	  int L;
	  L = strlen (C);
	  K = malloc (L + len + 1);
	  memcpy (K, C, L);
	  memcpy (K + L, s, len);
	  K[L + len] = 0;
	  free (C);
	}
      else
	{
	  K = malloc (len + 1);
	  memcpy (K, s, len);
	  K[len] = 0;
	}
      *D = K;
    }
}

static void
pnode_print (pnode_t * P)
{
  static int space = 0;
  int i;
  for (i = 0; i < space; i++)
    printf (" ");
  printf ("%s\n", P->name ? P->name : "<null>");
  space += 4;
  if (P->children)
    {
      typeof ((*P->children).head.next) N181, T181;
      for (T181 = (*P->children).head.next;
	   T181 != &((*P->children).head); T181 = N181)
	{
	  typeof (T181->data) Z;
	  Z = T181->data;
	  N181 = T181->next;

	  pnode_print (Z);

	}
    }

  space -= 4;
}

static int
get_int_attrib (char **attr, char *name)
{
  char *A;
  A = get_str_attrib (attr, name);
  if (A)
    return atoi (A);
  return 0;
}

static int
get_color_attrib (char **attr, char *name)
{
  char *A;
  char **components;
  int i;
  int icom[3];
  int C;
  A = get_str_attrib (attr, name);
  if (!A)
    return 0;
  components = strsplit (":", A);
  if (!components)
    return 0;
  for (i = 0; i < 3; i++)
    icom[i] = 0;
  for (i = 0; i < 3; i++)
    if (components[i])
      {
	icom[i] = phex (components[i]);
	free (components[i]);
      }
  free (components);
  C = 0;
  for (i = 0; i < 3; i++)
    C = (C << 8) | (icom[i] >> 8);
  return C;
}

static int
phex (char *x)
{
  int A;
  int i;
  A = 0;
  for (i = 0; i < 4 && x[i]; i++)
    {
      int Z;
      if (x[i] >= '0' && x[i] <= '9')
	Z = x[i] - '0';
      else if (x[i] >= 'A' && x[i] <= 'F')
	Z = x[i] - 'A' + 10;
      else if (x[i] >= 'a' && x[i] <= 'f')
	Z = x[i] - 'a' + 10;
      else
	Z = 0;
      A = (A << 4) | Z;
    }
  return A;
}

static char *
get_str_attrib (char **attr, char *name)
{
  int L;
  int i;
  for (L = 0; attr[L]; L++)
    ;
  for (i = 0; i < L; i += 2)
    if (!strcmp (attr[i], name))
      return attr[i + 1];
  return 0;
}

static char **
strsplit (char *re, char *d)
{
  regex_t rx;
  int ec;
  if ((ec = regcomp (&rx, re, REG_EXTENDED)))
    {
      char ebuf[2000];
      regerror (ec, &rx, ebuf, sizeof (ebuf) - 1);
      exit (fprintf (stderr, "regcomp for '%s' failed: %s\n", re, ebuf));
    }
  char *orig_d = d;
  int nfields;
  char **fields = 0;

again:
  d = orig_d;
  nfields = 0;
  while (*d)
    {
      regmatch_t matches[2];
      if (regexec (&rx, d, 2, matches, 0))
	{
	  if (fields)
	    fields[nfields] = collect_substr (d, strlen (d));
	  nfields++;
	  d += strlen (d);
	}
      else
	{
	  if (matches[0].rm_so == 0)
	    {
	      d += matches[0].rm_eo;
	    }
	  else
	    {
	      if (fields)
		fields[nfields] = collect_substr (d, matches[0].rm_so);
	      d += matches[0].rm_eo;
	      nfields++;
	    }
	}
    }
  if (fields)
    {
      regfree (&rx);
      return fields;
    }
  if (!nfields)
    {
      regfree (&rx);
      return 0;
    }

  fields = (typeof (fields)) calloc ((nfields + 1), sizeof (fields[0]));

  fields[nfields] = 0;
  goto again;
}

static char *
collect_substr (char *str, int len)
{
  char *x;

  x = (typeof (x)) calloc ((len + 1), sizeof (x[0]));

  memcpy (x, str, len);
  x[len] = 0;
  return x;
}
