/*

Copyright (c) 2009 Şükrü Çınar  (sukru cinar)

This program is distributed under GNU GPL v2. See file COPYING
for licensing details.

*/

#ifndef PARSEDOC_DOT_H_INCLUDED
#define PARSEDOC_DOT_H_INCLUDED

typedef struct
{
  int row, col;
  char *data;
} cell_t;
typedef struct
{
  char *data;
} merge_t;
typedef struct
{
  int startCol, startRow, endCol, endRow;
  int hAlign, vAlign, bgcolor, fgcolor;
  int bTop, bLeft, bRight, bBottom;
  int bold;
} styleregion_t;
struct cellist_t_NODE
{
  struct cellist_t_NODE *prev, *next;
  cell_t *data;
};
typedef struct
{
  struct cellist_t_NODE head;
} cellist_t;
struct mergelist_t_NODE
{
  struct mergelist_t_NODE *prev, *next;
  merge_t *data;
};
typedef struct
{
  struct mergelist_t_NODE head;
} mergelist_t;
struct styleregionlist_t_NODE
{
  struct styleregionlist_t_NODE *prev, *next;
  styleregion_t *data;
};
typedef struct
{
  struct styleregionlist_t_NODE head;
} styleregionlist_t;
typedef struct
{
  char *name;
  char *maxcol, *maxrow;
  cellist_t *cells;
  mergelist_t *merges;
  styleregionlist_t *styleregions;
} sheet_t;
struct sheetlist_t_NODE
{
  struct sheetlist_t_NODE *prev, *next;
  sheet_t *data;
};
typedef struct
{
  struct sheetlist_t_NODE head;
} sheetlist_t;
typedef struct
{
  sheetlist_t *sheets;
} doc_t;
#ifdef __cplusplus
extern "C"
{
#endif
  void cellist_init (cellist_t * L);
  cell_t *cellist_destroy (cellist_t * L);
  cellist_t *cellist_new ();
  void cellist_append (cellist_t * L, cell_t * data);
  void cellist_prepend (cellist_t * L, cell_t * data);
  void cellist_remove (cellist_t * L, struct cellist_t_NODE *n);
  int cellist_isempty (cellist_t * L);
  void mergelist_init (mergelist_t * L);
  merge_t *mergelist_destroy (mergelist_t * L);
  mergelist_t *mergelist_new ();
  void mergelist_append (mergelist_t * L, merge_t * data);
  void mergelist_prepend (mergelist_t * L, merge_t * data);
  void mergelist_remove (mergelist_t * L, struct mergelist_t_NODE *n);
  int mergelist_isempty (mergelist_t * L);
  void styleregionlist_init (styleregionlist_t * L);
  styleregion_t *styleregionlist_destroy (styleregionlist_t * L);
  styleregionlist_t *styleregionlist_new ();
  void styleregionlist_append (styleregionlist_t * L, styleregion_t * data);
  void styleregionlist_prepend (styleregionlist_t * L, styleregion_t * data);
  void
    styleregionlist_remove
    (styleregionlist_t * L, struct styleregionlist_t_NODE *n);
  int styleregionlist_isempty (styleregionlist_t * L);
  void sheetlist_init (sheetlist_t * L);
  sheet_t *sheetlist_destroy (sheetlist_t * L);
  sheetlist_t *sheetlist_new ();
  void sheetlist_append (sheetlist_t * L, sheet_t * data);
  void sheetlist_prepend (sheetlist_t * L, sheet_t * data);
  void sheetlist_remove (sheetlist_t * L, struct sheetlist_t_NODE *n);
  int sheetlist_isempty (sheetlist_t * L);
  doc_t *parse_doc (FILE * f);
#ifdef __cplusplus
}
#endif

#endif
