/*

Copyright (c) 2009 Şükrü Çınar  (sukru cinar)

This program is distributed under GNU GPL v2. See file COPYING
for licensing details.

*/

#include <stdlib.h>

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "repstr.h"

static int do_replace_string (char *data, char *from, char *to, char *buffer);

void *__unused_repstr_c[] = {

  0,
};

char *
replace_string_f (char *data, char *from, char *to)
{
  char *B;
  B = replace_string (data, from, to);
  free (data);
  return B;
}

char *
replace_string (char *data, char *from, char *to)
{
  char *B;
  B = malloc (do_replace_string (data, from, to, 0));
  do_replace_string (data, from, to, B);
  return B;
}

static int do_replace_string (char *data, char *from, char *to, char *buffer)
{
  int L;
  char *x;
  int Lto;
  int Lfrom;

  L = 0;
  Lto = strlen (to);
  Lfrom = strlen (from);

  while ((x = strstr (data, from)))
    {
      if (x != data)
	{
	  if (buffer)
	    memcpy (buffer + L, data, x - data);
	  L += x - data;
	}
      if (buffer)
	memcpy (buffer + L, to, Lto);
      L += Lto;
      data = x + Lfrom;
    }

  if (data[0])
    {
      Lto = strlen (data);
      if (buffer)
	memcpy (buffer + L, data, Lto);
      L += Lto;
    }

  if (buffer)
    buffer[L] = 0;
  L++;
  return L;
}

void strpairlist_init (strpairlist_t * L)
{
  L->head.prev = L->head.next = &L->head;
}

strpair_t *strpairlist_destroy (strpairlist_t * L)
{
  typeof (L->head.next) N;
  strpair_t *R;

  N = L->head.next;
  if (N == &L->head)
    return 0;
  R = N->data;

  strpairlist_remove (L, N);
  return R;
}

strpairlist_t *strpairlist_new ()
{
  strpairlist_t *L;
  L = (typeof (L)) malloc (sizeof (*L));
  L->head.prev = L->head.next = &L->head;
  return L;
}

void strpairlist_append (strpairlist_t * L, strpair_t * data)
{
  struct strpairlist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->prev = L->head.prev;
  n->next = &L->head;
  L->head.prev->next = n;
  L->head.prev = n;
}

void strpairlist_prepend (strpairlist_t * L, strpair_t * data)
{
  struct strpairlist_t_NODE *n;
  n = (typeof (n)) malloc (sizeof (n[0]));
  n->data = data;
  n->next = L->head.next;
  n->prev = &L->head;
  L->head.next->prev = n;
  L->head.next = n;
}

void strpairlist_remove (strpairlist_t * L, struct strpairlist_t_NODE *n)
{
  n->prev->next = n->next;
  n->next->prev = n->prev;
  free (n);
}

int strpairlist_isempty (strpairlist_t * L)
{
  return L->head.next == &L->head;
}

char *
do_replacements (char *src, strpairlist_t * reps)
{
  char *x;
  x = src;
  {
    typeof ((*reps).head.next) N8, T8;
    for (T8 = (*reps).head.next; T8 != &((*reps).head); T8 = N8)
      {
	typeof (T8->data) R;
	R = T8->data;
	N8 = T8->next;

	if (x == src)
	  x = replace_string (x, R->a, R->b);
	else
	  x = replace_string_f (x, R->a, R->b);

      }
  }

  return x;
}

strpair_t *
strpair_new (char *a, char *b)
{
  strpair_t *P;

  P = (typeof (P)) calloc (1, sizeof (P[0]));

  P->a = a;
  P->b = b;
  return P;
}

void
strpairlist_dump (strpairlist_t * L)
{
  {
    typeof ((*L).head.next) N15, T15;
    for (T15 = (*L).head.next; T15 != &((*L).head); T15 = N15)
      {
	typeof (T15->data) P;
	P = T15->data;
	N15 = T15->next;

	printf ("A=<%s>\n", P->a);
	printf ("B=<%s>\n", P->b);

      }
  }

}
