/*

Copyright (c) 2009 Şükrü Çınar  (sukru cinar)

This program is distributed under GNU GPL v2. See file COPYING
for licensing details.

*/

#ifndef REPSTR_DOT_H_INCLUDED
#define REPSTR_DOT_H_INCLUDED

typedef struct
{
  char *a, *b;
} strpair_t;
struct strpairlist_t_NODE
{
  struct strpairlist_t_NODE *prev, *next;
  strpair_t *data;
};
typedef struct
{
  struct strpairlist_t_NODE head;
} strpairlist_t;
#ifdef __cplusplus
extern "C"
{
#endif
  char *replace_string_f (char *data, char *from, char *to);
  char *replace_string (char *data, char *from, char *to);
  void strpairlist_init (strpairlist_t * L);
  strpair_t *strpairlist_destroy (strpairlist_t * L);
  strpairlist_t *strpairlist_new ();
  void strpairlist_append (strpairlist_t * L, strpair_t * data);
  void strpairlist_prepend (strpairlist_t * L, strpair_t * data);
  void strpairlist_remove (strpairlist_t * L, struct strpairlist_t_NODE *n);
  int strpairlist_isempty (strpairlist_t * L);
  char *do_replacements (char *src, strpairlist_t * reps);
  strpair_t *strpair_new (char *a, char *b);
  void strpairlist_dump (strpairlist_t * L);
#ifdef __cplusplus
}
#endif

#endif
