/*

Copyright (c) 2009 Şükrü Çınar  (sukru cinar)

This program is distributed under GNU GPL v2. See file COPYING
for licensing details.

*/

#ifndef STYLE_DOT_H_INCLUDED
#define STYLE_DOT_H_INCLUDED

enum border
{ b_left = 1, b_right = 2, b_top = 4, b_bottom = 8 };
enum align
{ al_begin, al_center, al_end };
enum cellkind
{ ck_empty, ck_header, ck_data, ck_merged };
typedef struct xcell
{
  enum cellkind kind;
  int row, col;
  char *data;
  int border;
  int halign, valign;
  int bgcolor, fgcolor;
  int bold;
  int colspan, rowspan;
  struct xcell *merged_to;
} xcell_t;
typedef struct
{
  xcell_t **cells;
  int ncols, nrows;
} grid_t;
#ifdef __cplusplus
extern "C"
{
#endif
  grid_t *apply_styles (sheet_t * sheet);
#ifdef __cplusplus
}
#endif

#endif
