#include <fx.h>
#include "flight_log_table.h"

FXDEFMAP(flight_log_table) flight_log_tableMessageMap[]={
	FXMAPFUNC(SEL_PAINT,0,flight_log_table::onPaint),
	FXMAPFUNC(SEL_LEFTBUTTONPRESS, 0, flight_log_table::onClick),
	FXMAPFUNC(SEL_COMMAND, flight_log_table::ID_UPDATECELL,
			flight_log_table::onCellChange),
};

FXIMPLEMENT(flight_log_table,FXScrollArea,
	flight_log_tableMessageMap,ARRAYNUMBER(flight_log_tableMessageMap))




void flight_log_table::create() { 
	FXScrollArea::create();

	data_font= new FXFont(myapp,"Courier New", 14);
	data_font->create();
	data_font_ascent= data_font->getFontAscent();
	data_font_height= data_font->getFontHeight();
	data_font_swidth= data_font->getCharWidth(' ');

	header_font= new FXFont(myapp, "Courier New", 14,FXFont::Bold);
	header_font->create();
	header_font_ascent= header_font->getFontAscent();
	header_font_height= header_font->getFontHeight();
	header_font_swidth= header_font->getCharWidth(' ');

	calculate_cell_content_geometries();
	calculate_col_widths();
	calculate_row_heights();
	convert_to_actual_coordinates();

	vertical->setLine(data_font_height);
	horizontal->setLine(data_font_swidth);
}

void flight_log_table::serialize_data(char **buf,size_t *len) {
	size_t *L;
	char **B;

	char *buffer;
	size_t buffer_len;

	buffer= 0;
	buffer_len= 0;
	L= &buffer_len;
	B= &buffer;

again:
		{int i;for(i=0;i<16;i++)
		S.date[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.atype[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.areg[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.depplc[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.deptm[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.arrplc[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.arrtm[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.se[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.me[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.mptime[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.ftime[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.ldg_day[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.ldg_ngt[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.opngt[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.opifr[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.ophood[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.fpic[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.fcop[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.fdual[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.finst[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.synth[i].serialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.rmk[i].serialize(B,L);}
	S.pg_mptime.serialize(B,L);
	S.pg_ftime.serialize(B,L);
	S.pg_ldg_day.serialize(B,L);
	S.pg_ldg_ngt.serialize(B,L);
	S.pg_opngt.serialize(B,L);
	S.pg_opifr.serialize(B,L);
	S.pg_ophood.serialize(B,L);
	S.pg_fpic.serialize(B,L);
	S.pg_fcop.serialize(B,L);
	S.pg_fdual.serialize(B,L);
	S.pg_finst.serialize(B,L);
	S.pg_synth.serialize(B,L);
	S.pp_mptime.serialize(B,L);
	S.pp_ftime.serialize(B,L);
	S.pp_ldg_day.serialize(B,L);
	S.pp_ldg_ngt.serialize(B,L);
	S.pp_opngt.serialize(B,L);
	S.pp_opifr.serialize(B,L);
	S.pp_ophood.serialize(B,L);
	S.pp_fpic.serialize(B,L);
	S.pp_fcop.serialize(B,L);
	S.pp_fdual.serialize(B,L);
	S.pp_finst.serialize(B,L);
	S.pp_synth.serialize(B,L);
	S.tot_mptime.serialize(B,L);
	S.tot_ftime.serialize(B,L);
	S.tot_ldg_day.serialize(B,L);
	S.tot_ldg_ngt.serialize(B,L);
	S.tot_opngt.serialize(B,L);
	S.tot_opifr.serialize(B,L);
	S.tot_ophood.serialize(B,L);
	S.tot_fpic.serialize(B,L);
	S.tot_fcop.serialize(B,L);
	S.tot_fdual.serialize(B,L);
	S.tot_finst.serialize(B,L);
	S.tot_synth.serialize(B,L);

	if (buffer) return ;
	buffer= (char*) malloc(buffer_len);
	*buf= buffer;
	*len= buffer_len;
	buffer_len= 0;
	goto again;
}

static void unparse_int(char **buffer, size_t *len, int value)
{
	if (*buffer) {
		memcpy(*buffer, (void*) &value, sizeof(value));
		*buffer += sizeof(value);
	}
	*len += sizeof(value);
}
static void unparse_str(char **buffer, size_t* len,char *value) {
	int L;
	if (value && value[0]) {
		L= strlen(value);
	} else L= 0;
	unparse_int(buffer, len, L);
	if (L) {
		if (*buffer) {
			memcpy(*buffer, value, L);
			*buffer+= L;
		}
		*len+= L;
	}
}


void flight_log_table::unparse_data(raw_storage_t *V,char **buf,size_t *len) {
	size_t *L;
	char **B;

	char *buffer;
	size_t buffer_len;

	buffer= 0;
	buffer_len= 0;
	L= &buffer_len;
	B= &buffer;

again:
		{int i; for(i=0;i<16;i++)
		unparse_str(B,L,V->date[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_str(B,L,V->atype[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_str(B,L,V->areg[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_str(B,L,V->depplc[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->deptm[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_str(B,L,V->arrplc[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->arrtm[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_str(B,L,V->se[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_str(B,L,V->me[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->mptime[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->ftime[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->ldg_day[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->ldg_ngt[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->opngt[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->opifr[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->ophood[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->fpic[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->fcop[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->fdual[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->finst[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_int(B,L,V->synth[i]);}
	{int i; for(i=0;i<16;i++)
		unparse_str(B,L,V->rmk[i]);}
	unparse_int(B,L,V->pg_mptime);
	unparse_int(B,L,V->pg_ftime);
	unparse_int(B,L,V->pg_ldg_day);
	unparse_int(B,L,V->pg_ldg_ngt);
	unparse_int(B,L,V->pg_opngt);
	unparse_int(B,L,V->pg_opifr);
	unparse_int(B,L,V->pg_ophood);
	unparse_int(B,L,V->pg_fpic);
	unparse_int(B,L,V->pg_fcop);
	unparse_int(B,L,V->pg_fdual);
	unparse_int(B,L,V->pg_finst);
	unparse_int(B,L,V->pg_synth);
	unparse_int(B,L,V->pp_mptime);
	unparse_int(B,L,V->pp_ftime);
	unparse_int(B,L,V->pp_ldg_day);
	unparse_int(B,L,V->pp_ldg_ngt);
	unparse_int(B,L,V->pp_opngt);
	unparse_int(B,L,V->pp_opifr);
	unparse_int(B,L,V->pp_ophood);
	unparse_int(B,L,V->pp_fpic);
	unparse_int(B,L,V->pp_fcop);
	unparse_int(B,L,V->pp_fdual);
	unparse_int(B,L,V->pp_finst);
	unparse_int(B,L,V->pp_synth);
	unparse_int(B,L,V->tot_mptime);
	unparse_int(B,L,V->tot_ftime);
	unparse_int(B,L,V->tot_ldg_day);
	unparse_int(B,L,V->tot_ldg_ngt);
	unparse_int(B,L,V->tot_opngt);
	unparse_int(B,L,V->tot_opifr);
	unparse_int(B,L,V->tot_ophood);
	unparse_int(B,L,V->tot_fpic);
	unparse_int(B,L,V->tot_fcop);
	unparse_int(B,L,V->tot_fdual);
	unparse_int(B,L,V->tot_finst);
	unparse_int(B,L,V->tot_synth);

	if (buffer) return ;
	buffer= (char*) malloc(buffer_len);
	*buf= buffer;
	*len= buffer_len;
	buffer_len= 0;
	goto again;
}

void flight_log_table::boxed_int::serialize(char **buffer,size_t *len) {
	unparse_int(buffer,len,value);
}

void flight_log_table::boxed_str::serialize(char **buffer, size_t *len)
{
	unparse_str(buffer,len,value);
}


static int parse_int(char **buffer,size_t *len)
{
	int X=0;
	if (*len>=sizeof(int)) {
		memcpy((void*) &X, *buffer, sizeof(int));
		*buffer+= sizeof(int);
		*len-= sizeof(int);
	}
	return X;
}

static char* parse_str(char **buffer,size_t *len) {
	size_t L;
	L= parse_int(buffer,len);
	if (L && *len>=L) {
		char *X;
		X= (char*) malloc(L+1);
		memcpy(X, *buffer, L);
		X[L]= 0;
		*buffer+= L;
		*len-= L;
		return X;
	} else return 0;
}



void flight_log_table::boxed_int::deserialize(char **buffer,size_t *len)
{
	value= parse_int(buffer,len);
	if (value || table->show_if_zero(row,col)) {
		char *X;
		X= table->format_int(value, 
			table->cell_defs[row][col].format);
		table->set_cell_text_noupdate(row,col,X);
		free(X);
	} else table->set_cell_text_noupdate(row,col,0);
}

void flight_log_table::boxed_str::deserialize(char **buffer,size_t *len)
{
	if (value) free(value);
	value= parse_str(buffer,len);
	table->set_cell_text_noupdate(row,col,value);
}


void flight_log_table::deserialize_data(char *buf,size_t len)
{
	char **B;
	size_t *L;
	B= &buf;
	L= &len;

		{int i;for(i=0;i<16;i++)
		S.date[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.atype[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.areg[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.depplc[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.deptm[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.arrplc[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.arrtm[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.se[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.me[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.mptime[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.ftime[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.ldg_day[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.ldg_ngt[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.opngt[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.opifr[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.ophood[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.fpic[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.fcop[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.fdual[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.finst[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.synth[i].deserialize(B,L);}
	{int i;for(i=0;i<16;i++)
		S.rmk[i].deserialize(B,L);}
	S.pg_mptime.deserialize(B,L);
	S.pg_ftime.deserialize(B,L);
	S.pg_ldg_day.deserialize(B,L);
	S.pg_ldg_ngt.deserialize(B,L);
	S.pg_opngt.deserialize(B,L);
	S.pg_opifr.deserialize(B,L);
	S.pg_ophood.deserialize(B,L);
	S.pg_fpic.deserialize(B,L);
	S.pg_fcop.deserialize(B,L);
	S.pg_fdual.deserialize(B,L);
	S.pg_finst.deserialize(B,L);
	S.pg_synth.deserialize(B,L);
	S.pp_mptime.deserialize(B,L);
	S.pp_ftime.deserialize(B,L);
	S.pp_ldg_day.deserialize(B,L);
	S.pp_ldg_ngt.deserialize(B,L);
	S.pp_opngt.deserialize(B,L);
	S.pp_opifr.deserialize(B,L);
	S.pp_ophood.deserialize(B,L);
	S.pp_fpic.deserialize(B,L);
	S.pp_fcop.deserialize(B,L);
	S.pp_fdual.deserialize(B,L);
	S.pp_finst.deserialize(B,L);
	S.pp_synth.deserialize(B,L);
	S.tot_mptime.deserialize(B,L);
	S.tot_ftime.deserialize(B,L);
	S.tot_ldg_day.deserialize(B,L);
	S.tot_ldg_ngt.deserialize(B,L);
	S.tot_opngt.deserialize(B,L);
	S.tot_opifr.deserialize(B,L);
	S.tot_ophood.deserialize(B,L);
	S.tot_fpic.deserialize(B,L);
	S.tot_fcop.deserialize(B,L);
	S.tot_fdual.deserialize(B,L);
	S.tot_finst.deserialize(B,L);
	S.tot_synth.deserialize(B,L);

	calculate_cell_content_geometries();
	calculate_col_widths();
	calculate_row_heights();
	convert_to_actual_coordinates();
	layout();
	update();
}

void flight_log_table::detach()
	{ FXScrollArea::detach();}

int flight_log_table::getContentWidth()
	{  return x_offsets[23]; }

int flight_log_table::getContentHeight()
	{ return y_offsets[21]; }

int flight_log_table::getDefaultWidth()
	{ return x_offsets[23]+vertical->getDefaultWidth() + 10;}

int flight_log_table::getDefaultHeight()
	{ return y_offsets[21]+horizontal->getDefaultHeight()+5; }

void flight_log_table::layout() {
	FXScrollArea::layout();
#if 0
	int K;
	K= x_offsets[23];
	if (K<width) x_pad= (width-K)/2;
	K= y_offsets[21];
	if (K<height) y_pad= (height-K)/2;
#endif
}


long flight_log_table::onPaint(FXObject* ob,FXSelector sel,void* ptr){
	FXEvent* event;
	crect_t R;
	int i,j;

	event=(FXEvent*)ptr;

	FXDCWindow dc(this,event);

	/* FIXME: subtract the painted areas from
		this and then do the paint */
	dc.setForeground(getBackColor());
	dc.fillRectangle(event->rect.x,event->rect.y,
		event->rect.w, event->rect.h);

	R.x1= event->rect.x- pos_x;
	R.y1= event->rect.y- pos_y;
	R.x2= R.x1+event->rect.w;
	R.y2= R.y1+event->rect.h;

	/* now, R is in document coordinates */

/*	printf("PAINT! %d,%d  [%d,%d]\n",R.x1,R.y1,R.x2,R.y2);
	printf("WINDOW: %d %d\n",getWidth(), getHeight());*/

	R.x1-= x_pad;
	R.x2-= x_pad;
	R.y1-= y_pad;
	R.y2-= y_pad;

	for(i=0;i<31;i++)
		if (rectangles_intersect(R, bgfills[i].area)) {
			dc.setForeground(bgfills[i].color);
			dc.fillRectangle(
				x_pad+bgfills[i].area.x1+pos_x,
				y_pad+bgfills[i].area.y1+pos_y,
				bgfills[i].area.x2-bgfills[i].area.x1,
				bgfills[i].area.y2-bgfills[i].area.y1);
		}

	dc.setForeground(rgb24tofxcolor(0x0));
	for(i=0;i<23;i++)
		if (xline_visible(R, horz_lines[i]))
			dc.drawLine(
				x_pad+horz_lines[i].x1+pos_x,
				y_pad+horz_lines[i].y+pos_y,
				x_pad+horz_lines[i].x2+pos_x,
				y_pad+horz_lines[i].y+pos_y);

	for(i=0;i<24;i++)
		if (yline_visible(R, vert_lines[i]))
			dc.drawLine(
				x_pad+vert_lines[i].x+pos_x,
				y_pad+vert_lines[i].y1+pos_y,
				x_pad+vert_lines[i].x+pos_x,
				y_pad+vert_lines[i].y2+pos_y);

	for(i=0;i<21;i++)
		for(j=0;j<23;j++) {
			cell_t *C;
			const cell_def_t *def;
			crect_t TR;
			C= &cells[i][j];
			def= &cell_defs[i][j];
			if (def->kind!=ck_header && def->kind!=ck_data)
				continue;
			if (!C->data || !C->data[0])
				continue;
			TR.x1= x_offsets[j];
			TR.y1= y_offsets[i];
			TR.x2= x_offsets[j+def->colspan];
			TR.y2= y_offsets[i+def->rowspan];
			if (!rectangles_intersect(R, TR))
				continue;
			render_text(&dc, TR, def->valign, def->halign,
				def->kind==ck_header, C->data,
				C->cwidth, C->cheight);
		}
	
	return 1;
}

long flight_log_table::onClick(FXObject* ob,FXSelector sel,void* ptr) {
	FXEvent* event;
	int x,y;
	int r,c;

	event=(FXEvent*)ptr;

	if (!editable) return 1;
	if (editor) {
		delete editor;
		editor= 0;
		return 1;
	}

	handle(this,FXSEL(SEL_FOCUS_SELF,0),ptr);
	x= event->win_x-pos_x; y= event->win_y-pos_y;

	y-= y_pad;
	x-= x_pad;

	for(r=0;r<21;r++)
		if (y>=y_offsets[r] && y<y_offsets[r+1])
			break;
	if (r==21) return 1;

	for(c=0;c<23;c++)
		if (x>=x_offsets[c]&&x<x_offsets[c+1])
			break;
	if (c==23) return 1;

	if (cell_defs[r][c].kind==ck_merged) {
		int a,b;
		a= r; b=c;
		r= cell_defs[a][b].merge_r;
		c= cell_defs[a][b].merge_c;
	}
	if (cell_defs[r][c].kind==ck_empty) return 1;
	if (cell_defs[r][c].kind==ck_header) return 1;
	if (!cell_defs[r][c].editable) return 1;

	start_edit(r,c);
	return 1;
}

void flight_log_table::make_cell_visible(int r,int c)
{
	int X= x_offsets[c]+pos_x;
	int Y= y_offsets[r]+pos_y;
	int W= x_offsets[c+cell_defs[r][c].colspan]-x_offsets[c];
	int H= y_offsets[r+cell_defs[r][c].rowspan]-y_offsets[r];
	int dx,dy;

	dx= dy= 0;

	if (X<0) { dx= X; X= 0; }

	if (X+W>=viewport_w) {
		if (X!=0) {
			dx+= -X;
			X= 0;
		}
	}

	if (Y<0) { dy= Y; Y= 0; }

	if (Y+H>=viewport_h) {
		if (Y!=0) {
			dy+= -Y;
			Y= 0;
		}
	}

	if (dx || dy) 
		setPosition(pos_x+dx,pos_y+dy);
}

void flight_log_table::start_edit(int r,int c) {

	if (r<0 || c<0 || r>=21 || c>=23)
		return ;
	make_cell_visible(r,c);
	editor= new FXTextField(this, 1, NULL, 0,
		FRAME_THICK, 
			x_pad+x_offsets[c]+pos_x,
			y_pad+y_offsets[r]+pos_y,
			x_offsets[c+cell_defs[r][c].colspan]-x_offsets[c],
			y_offsets[r+cell_defs[r][c].rowspan]-y_offsets[r]);
	editor->create();
	if (cells[r][c].data)
		editor->setText(cells[r][c].data);
	editor->setFocus();
	editor->setTarget(this);
	editor->setSelector(ID_UPDATECELL);
	editor->show();
	input_r= r;
	input_c= c;
}

long flight_log_table::onCellChange(FXObject* ob,FXSelector sel,void* ptr) {
	char *text;
	int intv;
	char *strv;
	int idx1,idx2;
	text= strdup(editor->getText().text());
	delete editor;
	editor= 0;

	strv= 0;
	switch (cell_defs[input_r][input_c].base_type) {
	case cell_int:
		intv= unformat_int(text,
				cell_defs[input_r][input_c].format);
		break;
	case cell_str:
		strv= unformat_str(text,
				cell_defs[input_r][input_c].format);
	}
	idx1= cell_defs[input_r][input_c].idx1;
	idx2= cell_defs[input_r][input_c].idx2;
	switch(cell_defs[input_r][input_c].skind) {
		case field_date: onccr_date(strv,idx1); break;
	case field_atype: onccr_atype(strv,idx1); break;
	case field_areg: onccr_areg(strv,idx1); break;
	case field_depplc: onccr_depplc(strv,idx1); break;
	case field_deptm: onccr_deptm(intv,idx1); break;
	case field_arrplc: onccr_arrplc(strv,idx1); break;
	case field_arrtm: onccr_arrtm(intv,idx1); break;
	case field_se: onccr_se(strv,idx1); break;
	case field_me: onccr_me(strv,idx1); break;
	case field_mptime: onccr_mptime(intv,idx1); break;
	case field_ftime: /* non-editable */ break;
	case field_ldg_day: onccr_ldg_day(intv,idx1); break;
	case field_ldg_ngt: onccr_ldg_ngt(intv,idx1); break;
	case field_opngt: onccr_opngt(intv,idx1); break;
	case field_opifr: onccr_opifr(intv,idx1); break;
	case field_ophood: onccr_ophood(intv,idx1); break;
	case field_fpic: onccr_fpic(intv,idx1); break;
	case field_fcop: onccr_fcop(intv,idx1); break;
	case field_fdual: onccr_fdual(intv,idx1); break;
	case field_finst: onccr_finst(intv,idx1); break;
	case field_synth: onccr_synth(intv,idx1); break;
	case field_rmk: onccr_rmk(strv,idx1); break;
	case field_pg_mptime: /* non-editable */ break;
	case field_pg_ftime: /* non-editable */ break;
	case field_pg_ldg_day: /* non-editable */ break;
	case field_pg_ldg_ngt: /* non-editable */ break;
	case field_pg_opngt: /* non-editable */ break;
	case field_pg_opifr: /* non-editable */ break;
	case field_pg_ophood: /* non-editable */ break;
	case field_pg_fpic: /* non-editable */ break;
	case field_pg_fcop: /* non-editable */ break;
	case field_pg_fdual: /* non-editable */ break;
	case field_pg_finst: /* non-editable */ break;
	case field_pg_synth: /* non-editable */ break;
	case field_pp_mptime: /* non-editable */ break;
	case field_pp_ftime: /* non-editable */ break;
	case field_pp_ldg_day: /* non-editable */ break;
	case field_pp_ldg_ngt: /* non-editable */ break;
	case field_pp_opngt: /* non-editable */ break;
	case field_pp_opifr: /* non-editable */ break;
	case field_pp_ophood: /* non-editable */ break;
	case field_pp_fpic: /* non-editable */ break;
	case field_pp_fcop: /* non-editable */ break;
	case field_pp_fdual: /* non-editable */ break;
	case field_pp_finst: /* non-editable */ break;
	case field_pp_synth: /* non-editable */ break;
	case field_tot_mptime: /* non-editable */ break;
	case field_tot_ftime: /* non-editable */ break;
	case field_tot_ldg_day: /* non-editable */ break;
	case field_tot_ldg_ngt: /* non-editable */ break;
	case field_tot_opngt: /* non-editable */ break;
	case field_tot_opifr: /* non-editable */ break;
	case field_tot_ophood: /* non-editable */ break;
	case field_tot_fpic: /* non-editable */ break;
	case field_tot_fcop: /* non-editable */ break;
	case field_tot_fdual: /* non-editable */ break;
	case field_tot_finst: /* non-editable */ break;
	case field_tot_synth: /* non-editable */ break;

	}
	free(text);

	if (strv) free(strv);
	return 1;
}

int flight_log_table::col(const char* X)
{
	int S=0;
	while(*X) {
		S= S*26 + X[0]-'A';
		X++;
	}
	return S;
}

int flight_log_table::fit_to_range(int x,int min,int max) {
	if (x<min) return min;
	else if (x>max) return max;
	else return x;
}

static void freeifnnull(char *x) {
	if (x) free(x);
}

flight_log_table::flight_log_table() { flags|=FLAG_ENABLED|FLAG_SHOWN;}
flight_log_table::~flight_log_table() {
	int i,j;
	for(i=0;i<21;i++)
		for(j=0;j<23;j++)
			if (cells[i][j].data)
				free(cells[i][j].data);

		for(i=0;i<16;i++)
		freeifnnull(S.date[i].value);
	for(i=0;i<16;i++)
		freeifnnull(S.atype[i].value);
	for(i=0;i<16;i++)
		freeifnnull(S.areg[i].value);
	for(i=0;i<16;i++)
		freeifnnull(S.depplc[i].value);
	for(i=0;i<16;i++)
		freeifnnull(S.arrplc[i].value);
	for(i=0;i<16;i++)
		freeifnnull(S.se[i].value);
	for(i=0;i<16;i++)
		freeifnnull(S.me[i].value);
	for(i=0;i<16;i++)
		freeifnnull(S.rmk[i].value);

}

flight_log_table::flight_log_table(FXComposite* p,
		FXuint opts,
		FXint x,FXint y,FXint w,FXint h)
	: FXScrollArea(p,opts,x,y,w,h)
{
	int i,j;
	flags |= FLAG_ENABLED;
	myapp= FXApp::instance();
	for(i=0;i<21;i++)
		for(j=0;j<23;j++) {
			cells[i][j].data= 0;
			cells[i][j].cwidth= cells[i][j].cheight= 0;
		}
		cells[0][1].data=strdup("DATE");
	cells[0][2].data=strdup("A/C\40or\40SIM");
	cells[0][4].data=strdup("DEPARTURE");
	cells[0][6].data=strdup("ARRIVAL");
	cells[0][8].data=strdup("SINGLE");
	cells[0][10].data=strdup("MULTI\12PILOT");
	cells[0][11].data=strdup("TOTAL\12TIME");
	cells[0][12].data=strdup("LANDING");
	cells[0][14].data=strdup("OPER\40CONDITION");
	cells[0][17].data=strdup("PILOT\40FUNCTION");
	cells[0][21].data=strdup("SYN\12TRN");
	cells[0][22].data=strdup("PIC\12RMK");
	cells[1][2].data=strdup("TYPE");
	cells[1][3].data=strdup("REG");
	cells[1][4].data=strdup("PLACE");
	cells[1][5].data=strdup("TIME");
	cells[1][6].data=strdup("PLACE");
	cells[1][7].data=strdup("TIME");
	cells[1][8].data=strdup("SE");
	cells[1][9].data=strdup("ME");
	cells[1][12].data=strdup("DAY");
	cells[1][13].data=strdup("NGT");
	cells[1][14].data=strdup("NGT");
	cells[1][15].data=strdup("IFR");
	cells[1][16].data=strdup("HOO");
	cells[1][17].data=strdup("PIC");
	cells[1][18].data=strdup("COP");
	cells[1][19].data=strdup("DUA");
	cells[1][20].data=strdup("INS");
	cells[2][0].data=strdup("1");
	cells[3][0].data=strdup("2");
	cells[4][0].data=strdup("3");
	cells[5][0].data=strdup("4");
	cells[6][0].data=strdup("5");
	cells[7][0].data=strdup("6");
	cells[8][0].data=strdup("7");
	cells[9][0].data=strdup("8");
	cells[10][0].data=strdup("9");
	cells[11][0].data=strdup("10");
	cells[12][0].data=strdup("11");
	cells[13][0].data=strdup("12");
	cells[14][0].data=strdup("13");
	cells[15][0].data=strdup("14");
	cells[16][0].data=strdup("15");
	cells[17][0].data=strdup("16");
	cells[18][1].data=strdup("PAGE\40TOTAL");
	cells[19][1].data=strdup("PREV\40PAGE\40TOTAL");
	cells[20][1].data=strdup("TOTAL");


	for(i=0;i<21;i++) row_heights[i]= 0;
	for(i=0;i<23;i++) col_widths[i]= 0;
	editor= 0;

		for(i=0;i<16;i++)
		S.date[i].init(this, i+2,1);
	for(i=0;i<16;i++)
		S.atype[i].init(this, i+2,2);
	for(i=0;i<16;i++)
		S.areg[i].init(this, i+2,3);
	for(i=0;i<16;i++)
		S.depplc[i].init(this, i+2,4);
	for(i=0;i<16;i++)
		S.deptm[i].init(this, i+2,5);
	for(i=0;i<16;i++)
		S.arrplc[i].init(this, i+2,6);
	for(i=0;i<16;i++)
		S.arrtm[i].init(this, i+2,7);
	for(i=0;i<16;i++)
		S.se[i].init(this, i+2,8);
	for(i=0;i<16;i++)
		S.me[i].init(this, i+2,9);
	for(i=0;i<16;i++)
		S.mptime[i].init(this, i+2,10);
	for(i=0;i<16;i++)
		S.ftime[i].init(this, i+2,11);
	for(i=0;i<16;i++)
		S.ldg_day[i].init(this, i+2,12);
	for(i=0;i<16;i++)
		S.ldg_ngt[i].init(this, i+2,13);
	for(i=0;i<16;i++)
		S.opngt[i].init(this, i+2,14);
	for(i=0;i<16;i++)
		S.opifr[i].init(this, i+2,15);
	for(i=0;i<16;i++)
		S.ophood[i].init(this, i+2,16);
	for(i=0;i<16;i++)
		S.fpic[i].init(this, i+2,17);
	for(i=0;i<16;i++)
		S.fcop[i].init(this, i+2,18);
	for(i=0;i<16;i++)
		S.fdual[i].init(this, i+2,19);
	for(i=0;i<16;i++)
		S.finst[i].init(this, i+2,20);
	for(i=0;i<16;i++)
		S.synth[i].init(this, i+2,21);
	for(i=0;i<16;i++)
		S.rmk[i].init(this, i+2,22);
	S.pg_mptime.init(this, 18,10);
	S.pg_ftime.init(this, 18,11);
	S.pg_ldg_day.init(this, 18,12);
	S.pg_ldg_ngt.init(this, 18,13);
	S.pg_opngt.init(this, 18,14);
	S.pg_opifr.init(this, 18,15);
	S.pg_ophood.init(this, 18,16);
	S.pg_fpic.init(this, 18,17);
	S.pg_fcop.init(this, 18,18);
	S.pg_fdual.init(this, 18,19);
	S.pg_finst.init(this, 18,20);
	S.pg_synth.init(this, 18,21);
	S.pp_mptime.init(this, 19,10);
	S.pp_ftime.init(this, 19,11);
	S.pp_ldg_day.init(this, 19,12);
	S.pp_ldg_ngt.init(this, 19,13);
	S.pp_opngt.init(this, 19,14);
	S.pp_opifr.init(this, 19,15);
	S.pp_ophood.init(this, 19,16);
	S.pp_fpic.init(this, 19,17);
	S.pp_fcop.init(this, 19,18);
	S.pp_fdual.init(this, 19,19);
	S.pp_finst.init(this, 19,20);
	S.pp_synth.init(this, 19,21);
	S.tot_mptime.init(this, 20,10);
	S.tot_ftime.init(this, 20,11);
	S.tot_ldg_day.init(this, 20,12);
	S.tot_ldg_ngt.init(this, 20,13);
	S.tot_opngt.init(this, 20,14);
	S.tot_opifr.init(this, 20,15);
	S.tot_ophood.init(this, 20,16);
	S.tot_fpic.init(this, 20,17);
	S.tot_fcop.init(this, 20,18);
	S.tot_fdual.init(this, 20,19);
	S.tot_finst.init(this, 20,20);
	S.tot_synth.init(this, 20,21);


	x_pad= 0;
	y_pad= 0;
}

void flight_log_table::convert_to_actual_coordinates() {
	int i;
	int S;
	
	for(S=0,i=0;i<=23;i++) {
		x_offsets[i]= S;
		S+= col_widths[i];
	}

	for(S=0,i=0;i<=21;i++) {
		y_offsets[i]= S;
		S+= row_heights[i];
	}

	for(i=0;i<23;i++) {
		horz_lines[i].y= y_offsets[horz_line_defs[i].y];
		horz_lines[i].x1= x_offsets[horz_line_defs[i].x1];
		horz_lines[i].x2= x_offsets[horz_line_defs[i].x2];
	}
	for(i=0;i<24;i++) {
		vert_lines[i].x= x_offsets[vert_line_defs[i].x];
		vert_lines[i].y1= y_offsets[vert_line_defs[i].y1];
		vert_lines[i].y2= y_offsets[vert_line_defs[i].y2];
	}
	for(i=0;i<31;i++) {
		const bgfill_def_t *D;
		bgfill_act_t *A;
		D= bgfill_defs + i;
		A= bgfills+i;
		A->color= rgb24tofxcolor(D->color);
		A->area.x1= x_offsets[D->area.x1];
		A->area.y1= y_offsets[D->area.y1];
		A->area.x2= x_offsets[D->area.x2];
		A->area.y2= y_offsets[D->area.y2];
	}
}


FXColor flight_log_table::rgb24tofxcolor(unsigned int x) {
	unsigned int r,g,b;
	r= (x>>16)&0xff;
	g= (x>>8) & 0xff;
	b= (x)&0xff;
	return FXRGB(r,g,b);
}

void flight_log_table::get_text_size(int bold,char *data, int *w,int *h)
{
	FXFont *font;
	char *x;
	int W=0;
	int H= 0;
	int tw,th;

	*w=0; *h= 0;
	font= bold ? header_font : data_font;
	if (!data || !data[0]) return ;
	
	while((x=strchr(data,'\n'))) {
		x[0]= 0;
		get_single_line_text_size(font, data, &tw, &th);
		x[0]= '\n';
		H+= th;
		if (tw>W) W= tw;
		data= x+1;
	}

	if (*data) {
		get_single_line_text_size(font, data, &tw, &th);
		H+= th;
		if (tw>W) W= tw;
	}

	*w= W;
	*h= H;
}

void flight_log_table::get_single_line_text_size
	(FXFont* font,char*data,int *tw,int *th)
{
	*tw= font->getTextWidth(data);
	*th= font->getFontHeight();
}

void flight_log_table::render_text
	(FXDC* dc,crect_t area, int valign,int halign, int bold,
	char *data,int content_width,int content_height)
{
	int X,Y;
	char *L;
	FXFont* font;

	if (!data || !data[0]) return ;
	font= bold ? header_font : data_font;

	X= area.x1;
	Y= area.y1;
	switch(valign) {
		case valign_top: break;
		case valign_bottom:
			Y= area.y2- content_height;
			break;
		case valign_center:
			Y= (area.y1+area.y2-content_height)/2;
			break;
	}
	while((L=strchr(data,'\n'))) {
		L[0]= 0;
		Y= render_text_line(dc,font,X, Y,
				halign, data,area.x2-area.x1);
		data= L+1;
		L[0]= '\n';
	}
	if (data[0])
		render_text_line(dc,font,X, Y,
				halign, data,area.x2-area.x1);
}



int flight_log_table::render_text_line
		(FXDC* dc,FXFont *font,int X, int Y,
		int halign, char *data, int avail_w)
{
	switch(halign) {
	case halign_left: break;
	case halign_right:
		X= X+avail_w-font->getTextWidth(data); 
		break;
	case halign_center:
		X= X+avail_w/2-font->getTextWidth(data)/2;
		break;
	}
	dc->setFont(font);
	dc->drawText(x_pad+X+pos_x,
		y_pad+Y+font->getFontAscent()+pos_y,
		data, strlen(data));
	return Y+font->getFontHeight();
}

void flight_log_table::calculate_cell_geometry(int i,int j) {
	switch(cell_defs[i][j].kind) {
	case ck_header: 
		get_text_size(1, cells[i][j].data,
		&cells[i][j].cwidth, &cells[i][j].cheight);
		break;
	case ck_data:
		if (cells[i][j].data && cells[i][j].data[0]) {
			get_text_size(0, cells[i][j].data,
			&cells[i][j].cwidth, &cells[i][j].cheight);
			break;
		}
	default:
		cells[i][j].cwidth= 0;
		cells[i][j].cheight= 0;
	}
}

void flight_log_table::calculate_cell_content_geometries()
{
	int i,j;
	for(i=0;i<21;i++)
		for(j=0;j<23;j++)
			calculate_cell_geometry(i,j);
}

int flight_log_table::calculate_row_heights()
{
	int i,j;
	int nh[21];
	for(i=0;i<21;i++) 
		nh[i]= 0;
	for(i=0;i<21;i++) 
		for(j=0;j<23;j++)  {
			int k;
			int a;
			if (!cell_defs[i][j].rowspan) continue;
			k= ceil(cells[i][j].cheight,cell_defs[i][j].rowspan);
			for(a=i;a<i+cell_defs[i][j].rowspan;a++)
				if (k>nh[a]) nh[a]= k;
		}
	for(i=0;i<21;i++)
		if (nh[i]!=row_heights[i]) {
			memcpy(row_heights, nh, sizeof(int)*21);
			return 1;
		}
	return 0;
}

int flight_log_table::calculate_col_widths()
{
	int i,j;
	int nw[23];
	for(j=0;j<23;j++)  
		nw[j]= 0;

	for(j=0;j<23;j++) 
		for(i=0;i<21;i++)  {
			int k;
			int a;
			if (!cell_defs[i][j].colspan) continue;
			k= ceil(cells[i][j].cwidth,cell_defs[i][j].colspan);
			for(a=j;a<j+cell_defs[i][j].colspan;a++)
				if (k>nw[a]) nw[a]= k;
		}
	for(j=0;j<23;j++)  
		if (nw[j]!=col_widths[j]) {
			memcpy(col_widths, nw, sizeof(int)*23);
			return 1;
		}
	return 0;
}

int flight_log_table::ceil(int a,int b) { return (a+b-1)/b; }

int flight_log_table::classify_point(crect_t R, int x,int y)
{
	int C;
	C= 0;
	if (x<R.x1) C|= 1; else if (x>=R.x2) C|=2;
	if (y<R.y1) C|=4; else if (y>=R.y2) C|= 8;
	return C;
}

int flight_log_table::rectangles_intersect(crect_t R1,crect_t R2)
{
	return (classify_point(R1, R2.x1,R2.y1) &
		 classify_point(R1, R2.x2,R2.y2))==0;
}

int flight_log_table::xline_visible(crect_t R, xline_t L)
{
	return (classify_point(R, L.x1, L.y) &
		 classify_point(R, L.x2, L.y))==0;
}

int flight_log_table::yline_visible(crect_t R,yline_t L)
{
	return (classify_point(R, L.x, L.y1) &
		 classify_point(R, L.x, L.y2))==0;
}

const flight_log_table::xline_t
flight_log_table::horz_line_defs[23] = {
	{ 0, 0, 23 },
{ 1, 2, 10 },
{ 1, 12, 21 },
{ 2, 0, 23 },
{ 3, 0, 23 },
{ 4, 0, 23 },
{ 5, 0, 23 },
{ 6, 0, 23 },
{ 7, 0, 23 },
{ 8, 0, 23 },
{ 9, 0, 23 },
{ 10, 0, 23 },
{ 11, 0, 23 },
{ 12, 0, 23 },
{ 13, 0, 23 },
{ 14, 0, 23 },
{ 15, 0, 23 },
{ 16, 0, 23 },
{ 17, 0, 23 },
{ 18, 0, 23 },
{ 19, 1, 22 },
{ 20, 1, 22 },
{ 21, 0, 23 },

};
const flight_log_table::yline_t
flight_log_table::vert_line_defs[24] = {
	{ 0, 0, 21 },
{ 1, 0, 21 },
{ 2, 0, 18 },
{ 3, 1, 18 },
{ 4, 0, 18 },
{ 5, 1, 18 },
{ 6, 0, 18 },
{ 7, 1, 18 },
{ 8, 0, 18 },
{ 9, 1, 18 },
{ 10, 0, 21 },
{ 11, 0, 21 },
{ 12, 0, 21 },
{ 13, 1, 21 },
{ 14, 0, 21 },
{ 15, 1, 21 },
{ 16, 1, 21 },
{ 17, 0, 21 },
{ 18, 1, 21 },
{ 19, 1, 21 },
{ 20, 1, 21 },
{ 21, 0, 21 },
{ 22, 0, 21 },
{ 23, 0, 21 },

};

const flight_log_table::bgfill_def_t
flight_log_table::bgfill_defs[31] = {
	{ {1, 2, 23, 3}, 0x00eeeeee},
{ {1, 4, 23, 5}, 0x00eeeeee},
{ {1, 6, 23, 7}, 0x00eeeeee},
{ {1, 8, 23, 9}, 0x00eeeeee},
{ {1, 10, 23, 11}, 0x00eeeeee},
{ {1, 12, 23, 13}, 0x00eeeeee},
{ {1, 14, 23, 15}, 0x00eeeeee},
{ {1, 16, 23, 17}, 0x00eeeeee},
{ {10, 18, 22, 19}, 0x00eeeeee},
{ {10, 20, 22, 21}, 0x00eeeeee},
{ {0, 11, 23, 12}, 0x00ffffff},
{ {0, 5, 23, 6}, 0x00ffffff},
{ {0, 3, 23, 4}, 0x00ffffff},
{ {0, 0, 23, 2}, 0x00ffffff},
{ {0, 2, 1, 3}, 0x00ffffff},
{ {0, 4, 1, 5}, 0x00ffffff},
{ {0, 9, 23, 10}, 0x00ffffff},
{ {0, 7, 23, 8}, 0x00ffffff},
{ {0, 6, 1, 7}, 0x00ffffff},
{ {0, 8, 1, 9}, 0x00ffffff},
{ {0, 10, 1, 11}, 0x00ffffff},
{ {0, 17, 10, 21}, 0x00ffffff},
{ {0, 15, 23, 16}, 0x00ffffff},
{ {0, 13, 23, 14}, 0x00ffffff},
{ {0, 12, 1, 13}, 0x00ffffff},
{ {0, 14, 1, 15}, 0x00ffffff},
{ {0, 16, 1, 17}, 0x00ffffff},
{ {10, 19, 23, 20}, 0x00ffffff},
{ {10, 17, 23, 18}, 0x00ffffff},
{ {22, 18, 23, 19}, 0x00ffffff},
{ {22, 20, 23, 21}, 0x00ffffff},

};

const flight_log_table::cell_def_t 
flight_log_table::cell_defs[21][23]= {
	{{ck_empty,0, 0, 2, 1, 0,0,0},
{ck_header, halign_center, valign_center, 2, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 2, 0,0,0},
{ck_merged, 0,0, 0,0, 0, 2, 0},
{ck_header, halign_center, valign_bottom, 1, 2, 0,0,0},
{ck_merged, 0,0, 0,0, 0, 4, 0},
{ck_header, halign_center, valign_bottom, 1, 2, 0,0,0},
{ck_merged, 0,0, 0,0, 0, 6, 0},
{ck_header, halign_center, valign_bottom, 1, 2, 0,0,0},
{ck_merged, 0,0, 0,0, 0, 8, 0},
{ck_header, halign_center, valign_bottom, 2, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 2, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 2, 0,0,0},
{ck_merged, 0,0, 0,0, 0, 12, 0},
{ck_header, halign_center, valign_bottom, 1, 3, 0,0,0},
{ck_merged, 0,0, 0,0, 0, 14, 0},
{ck_merged, 0,0, 0,0, 0, 14, 0},
{ck_header, halign_center, valign_bottom, 1, 4, 0,0,0},
{ck_merged, 0,0, 0,0, 0, 17, 0},
{ck_merged, 0,0, 0,0, 0, 17, 0},
{ck_merged, 0,0, 0,0, 0, 17, 0},
{ck_header, halign_center, valign_center, 2, 1, 0,0,0},
{ck_header, halign_center, valign_center, 2, 1, 0,0,0},
},
{{ck_merged, 0,0, 0,0, 0, 0, 0},
{ck_merged, 0,0, 0,0, 0, 1, 0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_merged, 0,0, 0,0, 0, 10, 0},
{ck_merged, 0,0, 0,0, 0, 11, 0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_merged, 0,0, 0,0, 0, 21, 0},
{ck_merged, 0,0, 0,0, 0, 22, 0},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 0, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 0, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 0, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 0, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 0, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 0, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 0, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 0, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 0, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 0, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 0, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 0, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 0, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 1, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 1, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 1, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 1, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 1, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 1, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 1, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 1, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 1, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 1, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 1, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 1, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 1, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 1, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 1, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 1, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 1, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 1, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 1, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 1, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 1, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 1, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 2, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 2, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 2, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 2, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 2, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 2, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 2, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 2, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 2, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 2, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 2, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 2, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 2, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 2, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 2, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 2, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 2, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 2, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 2, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 2, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 2, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 2, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 3, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 3, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 3, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 3, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 3, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 3, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 3, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 3, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 3, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 3, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 3, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 3, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 3, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 3, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 3, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 3, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 3, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 3, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 3, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 3, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 3, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 3, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 4, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 4, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 4, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 4, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 4, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 4, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 4, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 4, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 4, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 4, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 4, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 4, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 4, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 4, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 4, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 4, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 4, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 4, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 4, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 4, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 4, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 4, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 5, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 5, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 5, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 5, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 5, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 5, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 5, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 5, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 5, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 5, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 5, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 5, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 5, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 5, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 5, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 5, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 5, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 5, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 5, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 5, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 5, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 5, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 6, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 6, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 6, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 6, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 6, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 6, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 6, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 6, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 6, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 6, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 6, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 6, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 6, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 6, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 6, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 6, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 6, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 6, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 6, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 6, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 6, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 6, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 7, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 7, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 7, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 7, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 7, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 7, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 7, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 7, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 7, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 7, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 7, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 7, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 7, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 7, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 7, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 7, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 7, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 7, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 7, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 7, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 7, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 7, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 8, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 8, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 8, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 8, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 8, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 8, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 8, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 8, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 8, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 8, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 8, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 8, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 8, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 8, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 8, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 8, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 8, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 8, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 8, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 8, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 8, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 8, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 9, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 9, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 9, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 9, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 9, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 9, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 9, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 9, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 9, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 9, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 9, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 9, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 9, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 9, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 9, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 9, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 9, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 9, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 9, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 9, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 9, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 9, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 10, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 10, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 10, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 10, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 10, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 10, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 10, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 10, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 10, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 10, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 10, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 10, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 10, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 10, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 10, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 10, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 10, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 10, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 10, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 10, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 10, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 10, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 11, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 11, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 11, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 11, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 11, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 11, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 11, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 11, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 11, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 11, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 11, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 11, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 11, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 11, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 11, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 11, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 11, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 11, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 11, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 11, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 11, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 11, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 12, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 12, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 12, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 12, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 12, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 12, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 12, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 12, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 12, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 12, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 12, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 12, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 12, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 12, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 12, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 12, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 12, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 12, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 12, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 12, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 12, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 12, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 13, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 13, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 13, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 13, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 13, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 13, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 13, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 13, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 13, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 13, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 13, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 13, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 13, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 13, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 13, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 13, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 13, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 13, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 13, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 13, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 13, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 13, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 14, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 14, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 14, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 14, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 14, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 14, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 14, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 14, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 14, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 14, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 14, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 14, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 14, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 14, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 14, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 14, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 14, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 14, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 14, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 14, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 14, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 14, 0, 
0,0,},
},
{{ck_header, halign_center, valign_bottom, 1, 1, 0,0,0},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_date, 15, 0, 
"##.##.##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_atype, 15, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_areg, 15, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_depplc, 15, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_deptm, 15, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_arrplc, 15, 0, 
0,0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_arrtm, 15, 0, 
"##:##",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_se, 15, 0, 
"#",0,},
{ck_data, halign_center, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_me, 15, 0, 
"#",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_mptime, 15, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_ftime, 15, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_day, 15, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ldg_ngt, 15, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opngt, 15, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_opifr, 15, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_ophood, 15, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fpic, 15, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fcop, 15, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_fdual, 15, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_finst, 15, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 1, cell_int, field_synth, 15, 0, 
"##:##",0,},
{ck_data, halign_left, valign_bottom, 1, 1, 0,0,
 1, cell_str, field_rmk, 15, 0, 
0,0,},
},
{{ck_empty,0, 0, 3, 1, 0,0,0},
{ck_header, halign_right, valign_bottom, 1, 9, 0,0,0},
{ck_merged, 0,0, 0,0, 18, 1, 0},
{ck_merged, 0,0, 0,0, 18, 1, 0},
{ck_merged, 0,0, 0,0, 18, 1, 0},
{ck_merged, 0,0, 0,0, 18, 1, 0},
{ck_merged, 0,0, 0,0, 18, 1, 0},
{ck_merged, 0,0, 0,0, 18, 1, 0},
{ck_merged, 0,0, 0,0, 18, 1, 0},
{ck_merged, 0,0, 0,0, 18, 1, 0},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pg_mptime, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pg_ftime, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pg_ldg_day, 0, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pg_ldg_ngt, 0, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pg_opngt, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pg_opifr, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pg_ophood, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pg_fpic, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pg_fcop, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pg_fdual, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pg_finst, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pg_synth, 0, 0, 
"##:##",0,},
{ck_empty,0, 0, 3, 1, 0,0,0},
},
{{ck_merged, 0,0, 0,0, 18, 0, 0},
{ck_header, halign_right, valign_bottom, 1, 9, 0,0,0},
{ck_merged, 0,0, 0,0, 19, 1, 0},
{ck_merged, 0,0, 0,0, 19, 1, 0},
{ck_merged, 0,0, 0,0, 19, 1, 0},
{ck_merged, 0,0, 0,0, 19, 1, 0},
{ck_merged, 0,0, 0,0, 19, 1, 0},
{ck_merged, 0,0, 0,0, 19, 1, 0},
{ck_merged, 0,0, 0,0, 19, 1, 0},
{ck_merged, 0,0, 0,0, 19, 1, 0},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pp_mptime, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pp_ftime, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pp_ldg_day, 0, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pp_ldg_ngt, 0, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pp_opngt, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pp_opifr, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pp_ophood, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pp_fpic, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pp_fcop, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pp_fdual, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pp_finst, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_pp_synth, 0, 0, 
"##:##",0,},
{ck_merged, 0,0, 0,0, 18, 22, 0},
},
{{ck_merged, 0,0, 0,0, 18, 0, 0},
{ck_header, halign_right, valign_bottom, 1, 9, 0,0,0},
{ck_merged, 0,0, 0,0, 20, 1, 0},
{ck_merged, 0,0, 0,0, 20, 1, 0},
{ck_merged, 0,0, 0,0, 20, 1, 0},
{ck_merged, 0,0, 0,0, 20, 1, 0},
{ck_merged, 0,0, 0,0, 20, 1, 0},
{ck_merged, 0,0, 0,0, 20, 1, 0},
{ck_merged, 0,0, 0,0, 20, 1, 0},
{ck_merged, 0,0, 0,0, 20, 1, 0},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_tot_mptime, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_tot_ftime, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_tot_ldg_day, 0, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_tot_ldg_ngt, 0, 0, 
0,0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_tot_opngt, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_tot_opifr, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_tot_ophood, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_tot_fpic, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_tot_fcop, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_tot_fdual, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_tot_finst, 0, 0, 
"##:##",0,},
{ck_data, halign_right, valign_bottom, 1, 1, 0,0,
 0, cell_int, field_tot_synth, 0, 0, 
"##:##",0,},
{ck_merged, 0,0, 0,0, 18, 22, 0},
},

};


void flight_log_table::set_cell_text_noupdate(int r,int c,char *text) {
	if (c<0 || r<0 || c>=23 || r>=21) return ;
	if (cell_defs[r][c].kind!=ck_data) return ;
	if (cells[r][c].data)
		free(cells[r][c].data);
	if (text) text= strdup(text);
	cells[r][c].data= text;
}

void flight_log_table::set_cell_text(int r,int c,char *text) {
	if (c<0 || r<0 || c>=23 || r>=21) return ;
	if (cell_defs[r][c].kind!=ck_data) return ;
	set_cell_text_noupdate(r,c,text);
	calculate_cell_geometry(r,c);
}


void flight_log_table::begin_update() {
}

void flight_log_table::end_update() {
	if (calculate_col_widths())  {
		convert_to_actual_coordinates();
		recalc();
		layout();
	}
	update();
}


void flight_log_table::boxed_str::init(flight_log_table *tb,int r,int c) {
	value= 0;
	table= tb;
	row= r;
	col= c;
}

void flight_log_table::boxed_str::start_edit() {
	table->start_edit(row,col);
}


void flight_log_table::boxed_int::start_edit() {
	table->start_edit(row,col);
}

void flight_log_table::boxed_int::init(flight_log_table *tb,int r,int c) {
	value= 0;
	table= tb;
	row= r;
	col= c;
}

void flight_log_table::boxed_int::set(int v) {
	char *tmp;
	value = v;
	if (value || table->show_if_zero(row,col)) {
		tmp= table->format_int(v,
			table->cell_defs[row][col].format);
		table->set_cell_text(row,col,tmp);
		free(tmp);
	} else table->set_cell_text(row,col,0);
}

void flight_log_table::boxed_str::set(char *v) {
	if (value)
		free(value);
	if (v && v[0]) 
		value= strdup(v);
	else
		value= 0;
	table->set_cell_text(row,col,value);
}

char* flight_log_table::format_int(int v,const char *fmt)
{
	size_t ndigits;
	char buf[200];
	int i;
	char *D;
	char *x;
	char *b;
	size_t L;

	sprintf(buf,"%d",v);
	if (!fmt || !fmt[0])
		return strdup(buf);

	ndigits= 0;
	for(i=0;fmt[i];i++)
		if (fmt[i]=='#') ndigits++;

	L=  (ndigits>strlen(buf) ? ndigits : strlen(buf)) +
		strlen(fmt)-ndigits + 1;
	D= (char*) malloc(L);
	x= D+L-1;
	x[0]= 0;
	x--;
	b= buf+strlen(buf)-1;

	for(i=strlen(fmt)-1;i>=0;i--) {
		if (fmt[i]=='#') {
			if (b<buf) *x= '0';
			else {
				*x= *b;
				b--;
			}
			x--;
		} else {
			*x= fmt[i];
			x--;
		}
	}

	while(b>=buf) {
		*x= *b;
		x--; b--;
	}
	return D;
}

char *flight_log_table::format_str(char *v,const char* fmt)
{
	if (v)
		return strdup(v);
	else
		return 0;
}

char *flight_log_table::unformat_str(char *v,const char* fmt)
{
	if (v)
		return strdup(v);
	else
		return 0;
}

int flight_log_table::unformat_int(char *x,const char*fmt)
{
	int i;
	int j;
	if (!x) return 0;
	x= strdup(x);
	j= 0;
	for(i=0;x[i];i++)
		if ((x[i]>='0' && x[i]<='9') || (j==0 && x[i]=='-'))
			x[j++]= x[i];
	x[j]= 0;
	i= atoi(x);
	free(x);
	return i;
}

flight_log_table::raw_storage_t* flight_log_table::parse_data
	(char *buf,size_t len)
{
	char **B;
	size_t *L;
	raw_storage_t* obj;
	obj= (raw_storage_t*) malloc(sizeof(*obj));
	B= &buf;
	L= &len;

		{int i; for(i=0;i<16;i++)
		obj->date[i]=parse_str(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->atype[i]=parse_str(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->areg[i]=parse_str(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->depplc[i]=parse_str(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->deptm[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->arrplc[i]=parse_str(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->arrtm[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->se[i]=parse_str(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->me[i]=parse_str(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->mptime[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->ftime[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->ldg_day[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->ldg_ngt[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->opngt[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->opifr[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->ophood[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->fpic[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->fcop[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->fdual[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->finst[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->synth[i]=parse_int(B,L);}
	{int i; for(i=0;i<16;i++)
		obj->rmk[i]=parse_str(B,L);}
	obj->pg_mptime=parse_int(B,L);
	obj->pg_ftime=parse_int(B,L);
	obj->pg_ldg_day=parse_int(B,L);
	obj->pg_ldg_ngt=parse_int(B,L);
	obj->pg_opngt=parse_int(B,L);
	obj->pg_opifr=parse_int(B,L);
	obj->pg_ophood=parse_int(B,L);
	obj->pg_fpic=parse_int(B,L);
	obj->pg_fcop=parse_int(B,L);
	obj->pg_fdual=parse_int(B,L);
	obj->pg_finst=parse_int(B,L);
	obj->pg_synth=parse_int(B,L);
	obj->pp_mptime=parse_int(B,L);
	obj->pp_ftime=parse_int(B,L);
	obj->pp_ldg_day=parse_int(B,L);
	obj->pp_ldg_ngt=parse_int(B,L);
	obj->pp_opngt=parse_int(B,L);
	obj->pp_opifr=parse_int(B,L);
	obj->pp_ophood=parse_int(B,L);
	obj->pp_fpic=parse_int(B,L);
	obj->pp_fcop=parse_int(B,L);
	obj->pp_fdual=parse_int(B,L);
	obj->pp_finst=parse_int(B,L);
	obj->pp_synth=parse_int(B,L);
	obj->tot_mptime=parse_int(B,L);
	obj->tot_ftime=parse_int(B,L);
	obj->tot_ldg_day=parse_int(B,L);
	obj->tot_ldg_ngt=parse_int(B,L);
	obj->tot_opngt=parse_int(B,L);
	obj->tot_opifr=parse_int(B,L);
	obj->tot_ophood=parse_int(B,L);
	obj->tot_fpic=parse_int(B,L);
	obj->tot_fcop=parse_int(B,L);
	obj->tot_fdual=parse_int(B,L);
	obj->tot_finst=parse_int(B,L);
	obj->tot_synth=parse_int(B,L);

	return obj;
}

void flight_log_table::destroy_data(flight_log_table::raw_storage_t *obj) {
		{int i; for(i=0;i<16;i++)
		freeifnnull(obj->date[i]);}
	{int i; for(i=0;i<16;i++)
		freeifnnull(obj->atype[i]);}
	{int i; for(i=0;i<16;i++)
		freeifnnull(obj->areg[i]);}
	{int i; for(i=0;i<16;i++)
		freeifnnull(obj->depplc[i]);}
	{int i; for(i=0;i<16;i++)
		freeifnnull(obj->arrplc[i]);}
	{int i; for(i=0;i<16;i++)
		freeifnnull(obj->se[i]);}
	{int i; for(i=0;i<16;i++)
		freeifnnull(obj->me[i]);}
	{int i; for(i=0;i<16;i++)
		freeifnnull(obj->rmk[i]);}

	free(obj);
}

